var addhostObj = new AddHost();

AddHost.VIEW_FORM_ID = "view:addHostForm";

function AddHost()
{
	this.onClickOKBtn = function(thisObj, thisEvent)
	{
		if(!validateInputFields())
		{
			EventHandling.preventReturnValue(thisEvent);
			// resize the frame height preventing from the content overflow
			resizeFrameHeight();		
		}else{
			showWaitCursor(false);
		}

	};
	
	this.onClickProtocal = function (thisObj) 
	{		
		var agentPortField = $(AddHost.VIEW_FORM_ID+":agentPortInput");
		
		// If the automatic radio button is selected, clear and disable the port input.
		// The radio button value for automatic is -1.
		if (thisObj.value < 0) {
			agentPortField.value = "";
		    agentPortField.disabled = true;
		} else {
			agentPortField.disabled = false;
		}
	}
	
	
	this.init = function() {
	
		var radioBtns = document.getElementsByName(AddHost.VIEW_FORM_ID+":agentProtocolRadioButtons");
		var agentPortField = $(AddHost.VIEW_FORM_ID+":agentPortInput");
		// If the automatic radio button is checked, diskable the input and clear the field.
		// Because the deviation of IE and FF,  have to use the reverse order to locate the radio button for automatic.
	    if (radioBtns[radioBtns.length - 3].checked){
	    	agentPortField.value = "";
			agentPortField.disabled = true;
		}
	}
	
	function validateInputFields()
	{
		//hide all of the validation message at first
		hideAllValidationMsg();
		
		var ipValue = $(AddHost.VIEW_FORM_ID+":hostIPAddressInput").value;
		var userIdValue = $(AddHost.VIEW_FORM_ID+":hostUseridInput").value;
		var passwordValue = $(AddHost.VIEW_FORM_ID+":hostPasswordInput").value;
		var agentPortValue = $(AddHost.VIEW_FORM_ID+":agentPortInput").value;
		var smisVersionValue = $(AddHost.VIEW_FORM_ID+":smisVersionInput").value;
		var smisProfileValue = $(AddHost.VIEW_FORM_ID+":smisProfileInput").value;
		var interoNSValue = $(AddHost.VIEW_FORM_ID+":interopNamespaceInput").value;
		var smisNSValue = $(AddHost.VIEW_FORM_ID+":smisNamespaceInput").value;
		
		var ipv4Expression = /^(\d{1,3}\.){3}\d{1,3}$/;
		//DCR56(feature 14284) remove the IPv6 support
 		//var ipv6Expression = /^([0-9A-Fa-f]{1,4}:){7}[0-9A-Fa-f]{1,4}$/;
		var dnshostnameExpression= /^([a-zA-Z0-9-]+\.)*([a-zA-Z0-9-]+)$/
		//ip address can not be empty
		if(ipValue == null || ipValue == "")
		{
			$("hostip_nullmessage_div").style.display = "";
			return false;
		}
		
		// dnshome can't contain any character other than A-Z,a-z,0-9 and -(hyphen)
		if (!ipValue.match(ipv4Expression)){ //&& !ipValue.match(ipv6Expression)) {
			// The value of ip address field can't be recognized as IPv4
			if (ipValue.length > 75) {
				$("hostname_exceed_maxlength_div").style.display = "";
				return false;
			}
			if (!ipValue.match(dnshostnameExpression)) {
				$("hostname_illegal_char_div").style.display = "";
				return false;
			}
		}
		
		//user id can not be empty
		if(userIdValue == null || userIdValue == "")
		{
			$("userid_message_tr").style.display = "";
			return false;
		}
		//password can not be empty
		if(passwordValue == null || passwordValue == "")
		{
			$("password_message_tr").style.display = "";
			return false;
		}
		
		var MAX_TCPIP_PORT = 65535;
		//If the protocal is automatical, don't need the validation.
		if ($(AddHost.VIEW_FORM_ID+":agentPortInput").disabled != true) { 
			//agentport can not be empty if the protocal is HTTPS/HTTP
			if(agentPortValue == null || agentPortValue == "")
			{
				$("agentport_nullmessage_tr").style.display = "";
				return false;
			}else{
				//if not empty, only integer 1-65535 is allowed
				if(!isInteger(agentPortValue) || parseInt(agentPortValue) <= 0 || parseInt(agentPortValue) > MAX_TCPIP_PORT)
				{
					$("agentport_incorrectmessage_tr").style.display = "";
					return false;
				}
			}
		}
		
		//simis version can not be empty
		if(smisVersionValue == null || smisVersionValue == "")
		{
			$("smisversion_message_tr").style.display = "";
			return false;
		}
		//sims profile can not be empty
		if(smisProfileValue == null || smisProfileValue == "")
		{
			$("smisprofile_message_tr").style.display = "";
			return false;
		}
		//intero namespace can not be empty
		if(interoNSValue == null || interoNSValue == "")
		{
			$("interonamespace_message_tr").style.display = "";
			return false;
		}
		//simis namespace can not be empty
		if(smisNSValue == null || smisNSValue == "")
		{
			$("smisnamespace_message_tr").style.display = "";
			return false;
		}
		return true;
	};
	
	
	function hideAllValidationMsg()
	{
		$("hostip_nullmessage_div").style.display = "none";
		$("userid_message_tr").style.display = "none";
		$("password_message_tr").style.display = "none";
		$("agentport_nullmessage_tr").style.display = "none";
		$("agentport_incorrectmessage_tr").style.display = "none";
		$("smisversion_message_tr").style.display = "none";
		$("smisprofile_message_tr").style.display = "none";
		$("interonamespace_message_tr").style.display = "none";
		$("smisnamespace_message_tr").style.display = "none";
		$("hostname_illegal_char_div").style.display = "none";
		$("hostname_exceed_maxlength_div").style.display = "none";
	};
	
	function resizeFrameHeight(){
		// If this page is part of a dymanic frame in a shell, resize the frames
		if(parent && parent.window.frames["dynamicFrame"])
		{
			parent.resizeFrameHeight("dynamicFrame", "dynamicFrame");
		}
	} 
	

	
}