<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<%-- jsf:pagecode language="java" location="/src/pagecode/page/allresources/AddHost.java" --%><%-- /jsf:pagecode --%>
<HTML lang="<%=MessageFormatter.getCurrentLocaleString()%>">
<HEAD>

<%@ include file="/page/common/Header.jsp"%>
<BASE href="<%=basePath%>">

<%@ taglib uri="http://java.sun.com/jsf/html" prefix="h"%>
<%@ taglib uri="http://www.ibm.com/jsf/html_extended" prefix="hx"%>
<%@ taglib uri="http://java.sun.com/jsf/core" prefix="f"%>

<f:loadBundle basename="com.ibm.sysmgmt.scm.ar.nls.GWMARL" var="bundle" />

<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<META http-equiv="Content-Type" content="text/html; charset=UTF-8">
<META name="GENERATOR" content="IBM Software Development Platform">
<META http-equiv="Content-Style-Type" content="text/css">

<LINK rel="stylesheet" type="text/css" href="page/common/scmstyle.css"
	title="Style">

<SCRIPT type="text/javascript" src="page/common/common.js"></SCRIPT>
<SCRIPT type="text/javascript" src="page/allresources/AddHost.js"></SCRIPT>

<TITLE>Add Host</TITLE>

</HEAD>
<f:view>
	<hx:scriptCollector id="scriptCollector">
		<BODY onload="addhostObj.init()">
		<h:form id="addHostForm">

			<%@include file="/page/common/InlineMessagePlaceHolder.jsp"%>

			<h:outputText id="addHostInstructions" styleClass="scm_outputText"
				value="#{bundle.AddHost_Instructions}"></h:outputText>

			<HR/>

			<!-- ----------------------------------------- IP -------------------------------------- -->

			<h:outputText id="hostIPAddressLabel"
				styleClass="scm_outputTextTitle2"
				value="#{bundle.AddHost_HostIPAddress}"></h:outputText>

			<BR>

			<div style="padding-left: 10px"><h:outputText
				id="hostIPAddressAsterix" styleClass="scm_outputText"
				style="color: red" value="#{bundle.Common_Asterix}"></h:outputText>

			<h:inputText id="hostIPAddressInput" value="#{pc_AddHost.address}" styleClass="scm_inputText"></h:inputText>

			<hx:graphicImageEx id="hostIpAddressHelpImage"
				value="images/expandcollapse/help_plus.gif" style="cursor: pointer"
				alt='#{bundle.Common_Collapsed}'
				title='#{bundle.Common_Collapsed}'
				tabindex="0" onkeyup="selfClick(this,event);"
				onclick="toggleExpandCollapse(this, 'images/expandcollapse/help_plus.gif', '#{bundle.Common_Collapsed}', 'images/expandcollapse/help_minus.gif', '#{bundle.Common_Expanded}', 'hostIPAddressHelpDiv')">
			</hx:graphicImageEx>

			<h:outputLabel id="hostIPDescription" for="hostIPAddressInput" styleClass="scm_outputText"
				value="#{bundle.AddHost_HostIPInstructions}"></h:outputLabel> <BR>

			<div id="hostIPAddressHelpDiv" style="display: none"><h:outputText
				id="hostIPHelpMessage" escape="false" styleClass="scm_outputText"
				value="#{bundle.AddHost_HostIPHelpInstructions}"></h:outputText></div>
			</div>

			<div id="hostip_nullmessage_div"
				style="display:none; padding-left:24px;">
				<h:outputText id="hostip_null_message" styleClass="scm_outputTextError"
					value="#{bundle.AddHost_Validation_IP_Null}">
				</h:outputText>
			</div>
			
			<div id="hostname_exceed_maxlength_div"
				style="display:none; padding-left:24px;">
				<h:outputText id="hostname_exceed_maxlength_message" styleClass="scm_outputTextError"
					value="#{bundle.AddHost_Validation_DNS_Length_Exceed_MAX}">
				</h:outputText>
			</div>
			
			<div id="hostname_illegal_char_div"
				style="display:none; padding-left:24px;">
				<h:outputText id="hostname_illegal_char_message" styleClass="scm_outputTextError"
					value="#{bundle.AddHost_Validation_DNS_Has_Illegal_Char}">
				</h:outputText>
			</div>
			<BR>

			<!-- ----------------------------------------- LOGIN -------------------------------------- -->

			<h:outputText id="hostLoginLabel" styleClass="scm_outputTextTitle2"
				value="#{bundle.AddHost_HostLogin}"></h:outputText>

			<BR>

			<div style="padding-left: 10px"><h:outputText
				id="hostLoginDescription" styleClass="scm_outputText"
				value="#{bundle.AddHost_HostLoginDescription}"></h:outputText> <BR>

			<table>
				<tbody>
					<tr>
						<td><h:outputText id="hostUseridAsterix"
							styleClass="scm_outputText" style="color: red"
							value="#{bundle.Common_Asterix}"></h:outputText> <h:outputLabel
							id="hostUseridLabel" for="hostUseridInput" styleClass="scm_outputText"
							value="#{bundle.AddHost_UserID}"></h:outputLabel></td>
						<td><h:inputText id="hostUseridInput" styleClass="scm_inputText"
							value="#{pc_AddHost.userID}"></h:inputText></td>
					</tr>
					<tr id="userid_message_tr" style="display:none;">
						<td style="padding-left:13px">&nbsp;</td>
						<td><h:outputText id="userid_incorrect_message"
							styleClass="scm_outputTextError"
							value="#{bundle.AddHost_Validation_UserID_Null}"></h:outputText>
						</td>
					</tr>
					<tr>
						<td><h:outputText id="hostPasswordAsterix"
							styleClass="scm_outputText" style="color: red"
							value="#{bundle.Common_Asterix}"></h:outputText> <h:outputLabel
							id="hostPasswordLabel" for="hostPasswordInput" styleClass="scm_outputText"
							value="#{bundle.AddHost_Password}"></h:outputLabel></td>
						<td><h:inputSecret id="hostPasswordInput" styleClass="scm_pwdText"
							value="#{pc_AddHost.password}"></h:inputSecret></td>
					</tr>
					<tr id="password_message_tr" style="display:none;">
						<td style="padding-left:13px">&nbsp;</td>
						<td><h:outputText id="password_incorrect_message"
							styleClass="scm_outputTextError"
							value="#{bundle.AddHost_Validation_Password_Null}"></h:outputText>
						</td>
					</tr>
				</tbody>
			</table>

			</div>

			<BR>

			<!-- ----------------------------------------- ADVANCED -------------------------------------- -->
			<hx:graphicImageEx id="advancedArrowImage"
				value="images/expandcollapse/arrow_right.gif"
				style="cursor: pointer" alt='#{bundle.Common_Collapsed}'
				title='#{bundle.Common_Collapsed}'
				tabindex="0" onkeyup="selfClick(this,event);"
				onclick="toggleExpandCollapse(this, 'images/expandcollapse/arrow_right.gif', '#{bundle.Common_Collapsed}', 'images/expandcollapse/arrow_down.gif', '#{bundle.Common_Expanded}', 'advancedOptionsDiv')">
			</hx:graphicImageEx>


			<h:outputText id="advancedLabel" styleClass="scm_outputTextTitle2"
				value="#{bundle.AddHost_Advanced}"></h:outputText>

			<BR>

			<div id="advancedOptionsDiv"
				style="padding-left: 10px; display: none;">

			<table>
				<tbody>
					<tr>
						<td><h:outputLabel id="agentProtocolLabel"
							for="agentProtocolRadioButtons" styleClass="scm_outputText"
							value="#{bundle.AddHost_AgentProtocol}"></h:outputLabel></td>
						<td><h:selectOneRadio id="agentProtocolRadioButtons"
							value="#{pc_AddHost.agentProtocol}" styleClass="scm_outputText"
							onclick="addhostObj.onClickProtocal(this);">
							<f:selectItems id="agentProtocolItems" value="#{pc_AddHost.agentProtocolSelectItems}"></f:selectItems>
						</h:selectOneRadio></td>
					</tr>
					<tr>
						<td><h:outputLabel id="agentPortLabel" for="agentPortInput"
							styleClass="scm_outputText" value="#{bundle.AddHost_AgentPort}"></h:outputLabel>
						</td>
						<td><h:inputText id="agentPortInput"
							value="#{pc_AddHost.agentPort}" styleClass="scm_inputText" style="width: 220px"></h:inputText></td>
					</tr>
					<tr id="agentport_nullmessage_tr" style="display:none;">
						<td style="padding-left:13px">&nbsp;</td>
						<td><h:outputText id="agentport_null_message"
							styleClass="scm_outputTextError"
							value="#{bundle.AddHost_Validation_AgentPort_Null}"></h:outputText>
						</td>
					</tr>
					<tr id="agentport_incorrectmessage_tr" style="display:none;">
						<td style="padding-left:13px">&nbsp;</td>
						<td><h:outputText id="agentport_incorrect_message"
							styleClass="scm_outputTextError"
							value="#{bundle.AddHost_Validation_AgentPort_Incorrect}"></h:outputText>
						</td>
					</tr>
					<tr>
						<td><h:outputLabel id="smisVersionLabel" for="smisVersionInput"
							styleClass="scm_outputText" value="#{bundle.AddHost_SMISVersion}"></h:outputLabel>
						</td>
						<td><h:inputText id="smisVersionInput"
							value="#{pc_AddHost.smisVersion}" styleClass="scm_inputText" style="width: 220px"></h:inputText></td>
					</tr>
					<tr id="smisversion_message_tr" style="display:none;">
						<td style="padding-left:13px">&nbsp;</td>
						<td><h:outputText id="smisversion_null_message"
							styleClass="scm_outputTextError"
							value="#{bundle.AddHost_Validation_SMISVersion_Null}"></h:outputText>
						</td>
					</tr>
					<tr>
						<td><h:outputLabel id="smisProfileLabel" for="smisProfileInput"
							styleClass="scm_outputText" value="#{bundle.AddHost_SMISProfile}"></h:outputLabel>
						</td>
						<td><h:inputText id="smisProfileInput"
							value="#{pc_AddHost.smisProfile}" styleClass="scm_inputText" style="width: 220px"></h:inputText></td>
					</tr>
					<tr id="smisprofile_message_tr" style="display:none;">
						<td style="padding-left:13px">&nbsp;</td>
						<td><h:outputText id="smisprofile_null_message"
							styleClass="scm_outputTextError"
							value="#{bundle.AddHost_Validation_SMISProfile_Null}"></h:outputText>
						</td>
					</tr>
					<tr>
						<td><h:outputLabel id="interopNamespaceLabel" for="interopNamespaceInput"
							styleClass="scm_outputText"
							value="#{bundle.AddHost_InteropNamespace}"></h:outputLabel></td>
						<td><h:inputText id="interopNamespaceInput"
							value="#{pc_AddHost.interopNamespace}" styleClass="scm_inputText" style="width: 220px"></h:inputText></td>
					</tr>
					<tr id="interonamespace_message_tr" style="display:none;">
						<td style="padding-left:13px">&nbsp;</td>
						<td><h:outputText id="interonamespace_null_message"
							styleClass="scm_outputTextError"
							value="#{bundle.AddHost_Validation_InteropNamespace_Null}"></h:outputText>
						</td>
					</tr>
					<tr>
						<td><h:outputLabel id="smisNamespaceLabel" for="smisNamespaceInput"
							styleClass="scm_outputText"
							value="#{bundle.AddHost_SMISNamespace}"></h:outputLabel></td>
						<td><h:inputText id="smisNamespaceInput"
							value="#{pc_AddHost.smisNamespace}" styleClass="scm_inputText" style="width: 220px"></h:inputText></td>
					</tr>
					<tr id="smisnamespace_message_tr" style="display:none;">
						<td style="padding-left:13px">&nbsp;</td>
						<td><h:outputText id="smisnamespace_null_message"
							styleClass="scm_outputTextError"
							value="#{bundle.AddHost_Validation_SMISNamespace_Null}"></h:outputText>
						</td>
					</tr>
				</tbody>
			</table>

			</div>

			<BR>

			<h:commandButton type="submit" id="addHostOK"
				value="#{bundle.Common_OK}" action="#{pc_AddHost.addHost}"
				styleClass="scm_button" onclick="addhostObj.onClickOKBtn(this, event);"></h:commandButton>
			<h:commandButton type="submit" id="addHostCancel"
				value="#{bundle.Common_Cancel}" action="#{pc_AddHost.cancel}"
				onclick="this.form.target='_parent'" styleClass="scm_button"></h:commandButton>
			
			<script type="text/javascript">
				$("view:addHostForm:hostIPAddressInput").focus();
				document.body.scrollTop = 0;
			</script>

		</h:form>
		</BODY>
		<jsp:include page="/page/common/InlineMessages.jsp"></jsp:include>
	</hx:scriptCollector>
</f:view>