// Tree table functions

var MINUS_IMAGE = "images/expandcollapse/minus.gif";
var PLUS_IMAGE = "images/expandcollapse/plus.gif";

var CONTROLLER_PROPERTIES_DIALOG_PATH = "faces/page/allresources/ControllerProperties.jsp";
var HOST_PROPERTIES_DIALOG_PATH = "faces/page/allresources/HostProperties.jsp";

var isHostSelected = false;
var isControllerSelected = false;
var isHostNotConnected = false;

// ---------------------------------------- REFRESH ----------------------------------
function refresh()
{
	document.getElementById('dynamicFrame').src = document.getElementById('dynamicFrame').src;
	
	startShellLoading();
}

function setLastRefreshDate()
{
	document.getElementById('lastRefreshTimestamp').innerHTML = getLocalizedCurrentTime();
}

// ---------------------------------------- MENU ----------------------------------

function setupMenuOptions()
{
	menu = hX_5.getComponentById("view:form1:actionsMenu");
		
	// Add Host					(always enabled)
	
	// Remove Host 				(enabled when host is selected)
	if(isHostSelected)
	{
		enableMenuItem(menu, "view:form1:removeHostLink");
		$("view:form1:removeHostLink").onclick=removeHostClicked;
	}
	else
	{
		disableMenuItem(menu, "view:form1:removeHostLink");
		$("view:form1:removeHostLink").onclick="";
	}
	
	// Retry Connection
	if (isHostSelected && isHostNotConnected){
		enableMenuItem(menu, "view:form1:retryConnectionLink");
		$("view:form1:retryConnectionLink").onclick=retryConnectionClicked;
	}else{
		disableMenuItem(menu, "view:form1:retryConnectionLink");
		$("view:form1:retryConnectionLink").onclick="";
	}
	
	// Properties 				(enabled when either controller or host is selected)
	if(isHostSelected || isControllerSelected)
	{
		enableMenuItem(menu, "view:form1:propertiesLink");
		$("view:form1:propertiesLink").onclick=propertiesClicked;
	}
	else
	{
		disableMenuItem(menu, "view:form1:propertiesLink");
		$("view:form1:propertiesLink").onclick="";
	}
	
	// Long Running Tasks		(enabled when a controller is selected)
	if(isControllerSelected)
	{
		enableMenuItem(menu, "view:form1:longRunningTasksLink");
		$("view:form1:longRunningTasksLink").onclick=longrunningTaskClicked;
	}
	else
	{
		disableMenuItem(menu, "view:form1:longRunningTasksLink");
		$("view:form1:longRunningTasksLink").onclick="";
	}
	
	// Physical Resources 		(enabled when a controller is selected)
	if(isControllerSelected)
	{
		enableMenuItem(menu, "view:form1:physicalResourcesLink");
		$("view:form1:physicalResourcesLink").onclick=physicalResourcesClicked;
	}
	else
	{
		disableMenuItem(menu, "view:form1:physicalResourcesLink");
		$("view:form1:physicalResourcesLink").onclick="";
	}
	
	// Storage					(enabled when a controller is selected)
	if(isControllerSelected)
	{
		enableMenuItem(menu, "view:form1:storageLink");
		$("view:form1:storageLink").onclick=storageClicked;
	}
	else
	{
		disableMenuItem(menu, "view:form1:storageLink");
		$("view:form1:storageLink").onclick="";
	}
	
	// Locate Drives			(enabled when either controller or host is selected)
	if(isHostSelected || isControllerSelected)
	{
		enableMenuItem(menu, "view:form1:locateDrivesLink");
		$("view:form1:locateDrivesLink").onclick=locateDrivesClicked;
	}
	else
	{
		disableMenuItem(menu, "view:form1:locateDrivesLink");
		$("view:form1:locateDrivesLink").onclick="";
	}
	
	// Audit Log				(always enabled)

	// Device Log				(enabled when a controller is selected)
	if(isControllerSelected)
	{
		enableMenuItem(menu, "view:form1:deviceLogLink");
		$("view:form1:deviceLogLink").onclick=deviceLogClicked;
	}
	else
	{
		disableMenuItem(menu, "view:form1:deviceLogLink");
		$("view:form1:deviceLogLink").onclick="";
	}
	
	// Collect Support Data		(always enabled)
	
	menu.redraw();
}

// ---------------------------------------- TREE ----------------------------------

function toggle(id, image, event)
{	
	if(document.getElementById(id).style.display == "none")
	{
		document.getElementById(id).style.display = "block"
		
		image.src = MINUS_IMAGE;
		image.alt = document.getElementById("view:form1:minus_alt").innerHTML;
		image.title = document.getElementById("view:form1:minus_alt").innerHTML;
	}
	else
	{
		document.getElementById(id).style.display = "none";
		
		image.src = PLUS_IMAGE;
		image.alt = document.getElementById("view:form1:plus_alt").innerHTML;
		image.title = document.getElementById("view:form1:plus_alt").innerHTML;
		
		unselectSelectedIfNotVisible();
	}
}

function expandAll()
{
	for(x = 0; x < allIDs.length; x++)
	{
		if(document.getElementById(allIDs[x]))
		{
			document.getElementById(allIDs[x]).style.display = "block";
		}
		
		if(document.getElementById("image_" + allIDs[x]))
		{
			image = document.getElementById("image_" + allIDs[x]);
			image.src = MINUS_IMAGE;
			image.alt = document.getElementById("view:form1:minus_alt").innerHTML;
			image.title = document.getElementById("view:form1:minus_alt").innerHTML;
		}
	}
}

function collapseAll()
{
	for(x = 0; x < allIDs.length; x++)
	{
		if(document.getElementById(allIDs[x]))
		{
			document.getElementById(allIDs[x]).style.display = "none";
		}
		
		if(document.getElementById("image_" + allIDs[x]))
		{
			image = document.getElementById("image_" + allIDs[x]);
			image.src = PLUS_IMAGE;
			image.alt = document.getElementById("view:form1:plus_alt").innerHTML;
			image.title = document.getElementById("view:form1:plus_alt").innerHTML;
		}
	}
	
	unselectSelectedIfNotVisible();
}

// ---------------------------------------- CURRENT SELECTION ----------------------------------

function hostSelected(thisObj)
{
	isHostSelected = true;
	isControllerSelected = false;
	
	// Set the form fields
	document.getElementById("view:form1:isHostSelected").value="true";
	document.getElementById("view:form1:isControllerSelected").value="false";
	
	// Judge the host status. If not connected, set the isHostNotConnected to true;
	var attr_isconnected = thisObj.attributes.isconnected.value;
  	isHostNotConnected = (attr_isconnected == "true"? false : true);

	// 	Fixing the menu to have the following correct options  enabled
	setupMenuOptions();	
}

function controllerSelected()
{
	isHostSelected = false;
	isControllerSelected = true;
	
	// Set the form fields
	document.getElementById("view:form1:isHostSelected").value="false";
	document.getElementById("view:form1:isControllerSelected").value="true";
	
	// 	Fixing the menu to have the following correct options enabled 
	setupMenuOptions();	
}

function getSelectedRadioButton()
{
	radioButtons = document.getElementsByName("selectedResource");
	
	for(x = 0; x < radioButtons.length; x++)
	{
		if(radioButtons[x].checked)
		{
			return radioButtons[x];
		}
	}
	
	// No button was found	
	return null;
}

function getSelectedResourceID()
{
	selectedButton = getSelectedRadioButton();
	
	if(selectedButton)
	{
		return selectedButton.value;
	}
	
	// Nothing has been selected
	return null;
}

function unselectSelectedIfNotVisible()
{
	selectedButton = getSelectedRadioButton();

	// If there is nothing selected, then dont worry about it
	if(selectedButton)
	{
		// If it is not visible the offset height will 0
		if(selectedButton.offsetHeight == 0)
		{
			// Unselect
			selectedButton.checked = false;
			
			// Update variables
			isHostSelected = false;
			isControllerSelected = false;
		}
	}
	
	// 	Fixing the menu to have the following correct options enabled
	setupMenuOptions();	
}

// ---------------------------------------- ACTIONS ----------------------------------

function removeHostClicked()
{
	// Launch the modal
	document.getElementById("view:form1:removeHostLauncher").click();
}

function propertiesClicked()
{
	var selectedId = getSelectedResourceID();
	
	if(isControllerSelected)
	{
		showControllerProperties(selectedId);
	}
	else if(isHostSelected)
	{
		showHostProperties(selectedId);
	}
}

function showControllerProperties(id)
{
	//set title
	var title = $("view:controller_dialog_title").innerHTML;
	panelDialogObj.setPanelDialogTitle("view", title);
	var action = CONTROLLER_PROPERTIES_DIALOG_PATH;
	panelDialogObj.addParameter("controller_id", id);
	panelDialogObj.launchDialogPOST("view",action,'620');
}

function showHostProperties(id)
{
	//set title
	var title = $("view:host_dialog_title").innerHTML;
	panelDialogObj.setPanelDialogTitle("view", title);
	var action = HOST_PROPERTIES_DIALOG_PATH;
	panelDialogObj.addParameter("host_id", id);
	panelDialogObj.launchDialogPOST("view",action,'620');
}

function showHostRetryConnectionDialog() {
	var selectedHostId = getSelectedResourceID();
	
	var title = $("view:retry_connection_dialog_title").innerHTML;
	panelDialogObj.setPanelDialogTitle("view", title);
	var action = "faces/page/allresources/RetryConnection.jsp";
	panelDialogObj.addParameter("host_id", selectedHostId);
	panelDialogObj.launchDialogPOST("view",action,'620');

}

function locateDrivesClicked()
{
	var selectedId = getSelectedResourceID();
	
	// Make sure to clear out any previously selected resources
	locateObject.removeAllResourcesToLocate();
	
	// Add the currently selected object
	locateObject.addResourceToLocate(selectedId);

	if(isControllerSelected)
	{
		locateObject.setLocateType(locateObject.CONTROLLER_CONSTANT);
	}
	else if(isHostSelected)
	{
		locateObject.setLocateType(locateObject.HOST_CONSTANT);
	}
	
	// Start the locate
	locateObject.startLocate();
}

function addHostClicked()
{
	parent.getElementByIdSuffix("form1:btn_add_host", "input").click();
}

function physicalResourcesClicked()
{
	$("view:form1:physical_resources_launcher").click();
}

function storageClicked()
{
	$("view:form1:storage_launcher").click();
}

function longrunningTaskClicked()
{
	$("view:form1:longrunning_task_launcher").click();
}

function deviceLogClicked()
{
	$("view:form1:devicelog_launcher").click();
}

function collectSupportDataClicked()
{
	$("view:form1:collect_supportdata_launcher").click();
}

function retryConnectionClicked()
{
	showHostRetryConnectionDialog();
}
