<%-- jsf:pagecode language="java" location="/src/pagecode/page/allresources/ControllerProperties.java" --%><%-- /jsf:pagecode --%>
<HTML lang="<%=MessageFormatter.getCurrentLocaleString()%>">
<HEAD>

<%@ include file="/page/common/Header.jsp"%>
<BASE href="<%=basePath%>">
<%@taglib uri="http://java.sun.com/jsf/core" prefix="f"%>
<%@taglib uri="http://java.sun.com/jsf/html" prefix="h"%>
<%@taglib uri="http://www.ibm.com/jsf/html_extended" prefix="hx"%>
<%@taglib uri="http://www.ibm.com/jsf/BrowserFramework" prefix="odc"%>

<f:loadBundle basename="com.ibm.sysmgmt.scm.ar.nls.GWMARL" var="bundle" />

<%@page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>

<link rel="stylesheet" type="text/css" href="page/common/scmstyle.css"
	title="Style">

<SCRIPT type="text/javascript" src="page/common/common.js"></SCRIPT>

<script type="text/javascript" src="page/allresources/PropertyDialog.js"></script>

<TITLE>Controller Properties</TITLE>

</HEAD>
<f:view>
	<BODY>
	<hx:scriptCollector id="scriptCollector"
		preRender="#{pc_ControllerProperties.onPageLoadBegin}">
		<h:form id="form1" styleClass="scm_outputText">
			<hx:commandExButton id="alarm_launcher" type="submit" value="alarm_launcher" action="#{pc_ControllerProperties.doAlarmAction}" 
				style="display:none;">
			</hx:commandExButton>
				<h:inputHidden id="actiontype" value=""/>
				<h:inputHidden id="controller_id" value="#{controllerPropertiesBean.controllerID}"/>
				<hx:jspPanel id="contentPanel" rendered="true">
					<div id="header">
						<div id="inline_message_panel" onclick="resizeDialogHeight(this, event);">
							<hx:jspPanel id="inline_message_include">
								<%@include file="/page/common/InlineMessagePlaceHolder.jsp"%>
							</hx:jspPanel>
						</div>
					<table style="width:100%; border-width:0; vertical-align:middle;">
						<tr>
							<td width="1%" valign="top">
								<hx:graphicImageEx
								id="imageHeader" styleClass="graphicImageEx"
								value="/images/components/controller_large.gif" alt="#{bundle.ControllerProperties_ControllerImage_Alt}"></hx:graphicImageEx>
							</td>
							<td valign="top">
								<table width="100%">
									<tr>
										<td width="1%" valign="top">
											<h:outputText
											styleClass="scm_outputText" style="display:block; float:left;"
											id="head_name" value="#{bundle.ControllerProperties_Label_Name}"></h:outputText>
										</td>
										<td valign="top" align="left">
											<h:outputText styleClass="scm_outputText" id="head_name_value"
											value="#{controllerPropertiesBean.controller.displayName}" style="padding-left:	10px;"></h:outputText>
										</td>
									</tr>
									<tr>
										<td width="1%" valign="top">
											<h:outputText
											styleClass="scm_outputText"
											style="display:block; float:left;"
											id="head_status"
											value="#{bundle.ControllerProperties_Label_Status}"></h:outputText>
										</td>
										<td valign="top" align="left">
											<div style="padding-left: 10px;">
												<hx:graphicImageEx id="imageStatus" styleClass="graphicImageEx"
												value="#{controllerPropertiesBean.controller.statusImage}" alt="">
												</hx:graphicImageEx>
												<h:outputText styleClass="scm_outputText" id="head_status_value"
											value="#{controllerPropertiesBean.controller.statusText}"></h:outputText>
											</div>

										</td>
									</tr>
								</table>
							</td>
<%-- Action menu is not shown per UCD SCM_MR_GUI_HLD_09_22_08. Code logic is ready for all actions, to restore the function, simply uncomment the content below--%>
<%--
							<td align="left" valign="top">
								<hx:panelMenu flyOpen="false" id="actionmenu" styleClass="scm_actionMenu">
									<f:facet name="header">
										<h:panelGroup id="btn_group">
											<hx:commandExButton value="#{bundle.ControllerProperties_Menu_Actions}" id="action_btn" styleClass="scm_actionMenu_Button"></hx:commandExButton>
											<hx:graphicImageEx value="/images/menu/sortdescon.gif" id="btn_img" styleClass="scm_actionMenu_Button_Icon" alt="#{bundle.Common_Menu_Actions}"></hx:graphicImageEx>
				  						</h:panelGroup>
									</f:facet>
									<hx:outputLinkEx value="javascript:;" onclick="" id="enable_alarm_link">
										<h:outputText id="enable_alarm_text" styleClass="scm_outputText"
											value="#{bundle.ControllerProperties_Menu_Enable_Alarm}"></h:outputText>
										<f:attribute name="itemDisabled" value="true"></f:attribute>
									</hx:outputLinkEx>
									<hx:outputLinkEx value="javascript:;" onclick="" id="disable_alarm_link">
										<h:outputText id="disable_alarm_text" styleClass="scm_outputText"
											value="#{bundle.ControllerProperties_Menu_Disable_Alarm}"></h:outputText>
										<f:attribute name="itemDisabled" value="true"></f:attribute>
									</hx:outputLinkEx>
									<hx:outputLinkEx value="javascript:;" onclick="" id="silence_alarm_link">
										<h:outputText id="silence_alarm_text" styleClass="scm_outputText"
											value="#{bundle.ControllerProperties_Menu_Silence_Alarm}"></h:outputText>
										<f:attribute name="itemDisabled" value="true"></f:attribute>
									</hx:outputLinkEx>
								</hx:panelMenu>
							</td>
--%>
							<td width="1%" align="right" valign="top">
								<a class="scm_plainLink" onclick="javascript:window.open('/help/topic/com.ibm.storage.armr.doc/scm_armr_controller_properties.html?noframes=true','PortletHelpWindow','resizable=yes,scrollbars=yes,menubar=no,toolbar=no,status=no,width=450,height=260,screenX=200,screenY=200,top=200,left=200').focus(); return false;" target="_blank" style="" href="/help/topic/com.ibm.storage.armr.doc/scm_armr_controller_properties.html?noframes=true">
									<h:outputText id="link_text" value="#{bundle.Common_Link_Help}"></h:outputText>
								</a>
							</td>
						</tr>
					</table>
					</div>
					
					<br>
					<div id="main"><odc:tabbedPanel styleClass="scm_tabbedPanel_top" width="100%"
						variableTabLength="true" showBackNextButton="false"
						showTabs="true"	id="tabbedPanel" height="330" id="controller_tab_panel">
						<odc:bfPanel id="controller_general" name="#{bundle.ControllerProperties_Tab_General}"
							showFinishCancelButton="false">
							<hx:jspPanel id="generaltab_jsppanel">
								<table>
									<tr>
										<td><h:outputText styleClass="scm_outputText"
											id="alarm_status_label"
											value="#{bundle.ControllerProperties_Label_Alarm_Status}"></h:outputText>
										</td>
										<td>
											<h:outputText styleClass="scm_outputText"
												id="alarm_status"
												value="#{controllerPropertiesBean.controller.alarmStatusText}"></h:outputText>
										</td>
									</tr>
									<tr>
										<td><h:outputText styleClass="scm_outputText"
											id="battery_status_label"
											value="#{bundle.ControllerProperties_Label_Battery_Install_Status}"></h:outputText>
										</td>
										<td>
											<h:graphicImage  id="bbuStatusImage" rendered="#{controllerPropertiesBean.controller.hasBBU}"
												value="#{controllerPropertiesBean.controller.bbuStatusImage}" alt="" style="vertical-align: middle">
											</h:graphicImage>			
											<h:outputText id="bbuStatusText" styleClass="scm_outputText" rendered="#{controllerPropertiesBean.controller.hasBBU}" 
												value="#{controllerPropertiesBean.controller.bbuStatusText}">
											</h:outputText>
										
											<!-- In case there is no BBU installed -->
											<h:outputText id="bbuNotIstalled" styleClass="scm_outputText" rendered="#{!controllerPropertiesBean.controller.hasBBU}" 
												value="#{bundle.ControllerProperties_BBU_None}"></h:outputText>
										</td>
									</tr>
									<tr>
										<td><h:outputText styleClass="scm_outputText"
											id="memory_size_label"
											value="#{bundle.ControllerProperties_Label_Memory_Size}"></h:outputText>
										</td>
										<td><h:outputText styleClass="scm_outputText"
											id="memory_size_value"
											value="#{controllerPropertiesBean.controller.memorySize}"></h:outputText>
										</td>
									</tr>
									<tr>
										<td><h:outputText styleClass="scm_outputText"
											id="firmware_package_level_label"
											value="#{bundle.ControllerProperties_Label_Firmware_Package_Level}"></h:outputText>
										</td>
										<td><h:outputText styleClass="scm_outputText"
											id="firmware_package_level_value"
											value="#{controllerPropertiesBean.controller.firmwarePackageLevel}"></h:outputText>
										</td>
									</tr>
									<tr>
										<td><h:outputText styleClass="scm_outputText"
											id="firmware_level_label"
											value="#{bundle.ControllerProperties_Label_Firmware_Level}"></h:outputText>
										</td>
										<td><h:outputText styleClass="scm_outputText"
											id="firmware_level_value"
											value="#{controllerPropertiesBean.controller.firmwareLevel}"></h:outputText>
										</td>
									</tr>
									<tr>
										<td colspan="2"><h:outputText styleClass="scm_outputText"
											id="port_addr_label"
											value="#{bundle.ControllerProperties_Label_Port_Addresses}"></h:outputText>
										</td>
									</tr>
									
									<hx:dataIterator id="ports_dataiterator" value="#{controllerPropertiesBean.controller.sasPorts}" var="port">
									<hx:jspPanel id="ports_jsppanel">
										<tr>
											<td style="padding-left:20px;">
												<h:outputFormat id="portindex_outputformat" styleClass="scm_outputText" value="#{bundle.ControllerProperties_Label_Port}">
													<f:param name="portindex_param" value="#{port.index}"></f:param>
												</h:outputFormat>
											</td>
											<td>
												<h:outputText id="portaddress_outputtext" styleClass="scm_outputText" value="#{port.macAddress}"></h:outputText>
											</td>
										</tr>
									</hx:jspPanel>
									</hx:dataIterator>

									<tr>
										<td colspan="2"><h:outputText styleClass="scm_outputText"
											id="product_numbers_label"
											value="#{bundle.ControllerProperties_Label_Product_Numbers}"></h:outputText>
										</td>
									</tr>
									<tr>
										<td style="padding-left:20px;"><h:outputText
											styleClass="scm_outputText" id="product_id_label"
											value="#{bundle.ControllerProperties_Label_Product_ID}"></h:outputText>
										</td>
										<td><h:outputText styleClass="scm_outputText"
											id="product_id_value"
											value="#{controllerPropertiesBean.controller.productId}"></h:outputText>
										</td>
									</tr>
									<tr>
										<td style="padding-left:20px;"><h:outputText
											styleClass="scm_outputText" id="mfr_label"
											value="#{bundle.ControllerProperties_Label_Manufacturer_ID}"></h:outputText>
										</td>
										<td><h:outputText styleClass="scm_outputText"
											id="mfr_value"
											value="#{controllerPropertiesBean.controller.manufacturerId}"></h:outputText>
										</td>
									</tr>
									<tr>
										<td style="padding-left:20px;"><h:outputText
											styleClass="scm_outputText" id="fru_sn_label"
											value="#{bundle.ControllerProperties_Label_FRU_SN}"></h:outputText>
										</td>
										<td><h:outputText styleClass="scm_outputText"
											id="fru_sn_value"
											value="#{controllerPropertiesBean.controller.fruSn}"></h:outputText>
										</td>
									</tr>
								</table>
							</hx:jspPanel>
						</odc:bfPanel>
						<f:facet name="back">
							<hx:commandExButton type="submit" value="&lt; Back"
								id="tabbedPanel_back" style="display:none"></hx:commandExButton>
						</f:facet>
						<f:facet name="next">
							<hx:commandExButton type="submit" value="Next &gt;"
								id="tabbedPanel_next" style="display:none"></hx:commandExButton>
						</f:facet>
						<f:facet name="finish">
							<hx:commandExButton type="submit" value="Finish"
								id="tabbedPanel_finish" style="display:none"></hx:commandExButton>
						</f:facet>
						<f:facet name="cancel">
							<hx:commandExButton type="submit" value="Cancel"
								id="tabbedPanel1sscancel" style="display:none"></hx:commandExButton>
						</f:facet>
					</odc:tabbedPanel></div>
					<br>
					<div id="footer"><hx:commandExButton type="button"
						styleClass="scm_button"
						value="#{bundle.Common_Button_Close}" id="btn_close" onclick="parent.panelDialogObj.closeDialog()">
					</hx:commandExButton></div>
					<jsp:include flush="true" page="/page/common/InlineMessages.jsp"></jsp:include>
				</hx:jspPanel>
			</h:form>
			<%-- controller dialog title --%>
			<h:outputText id="controller_dialog_title" value="#{controllerPropertiesBean.controllerDialogTitle}" style="display:none"></h:outputText>
			
	</hx:scriptCollector>
	</BODY>
</f:view>
</HTML>
<script language="javascript">
var title = $("view:controller_dialog_title").innerHTML;
parent.panelDialogObj.setPanelDialogTitle("view", title);
/**
//Action menu is not shown per UCD SCM_MR_GUI_HLD_09_22_08. Code logic is ready for all actions, to restore the function, simply uncomment the content below
setTimeout("controllerActionMenu.init()",800);
*/
</script>
