function LocateObject()
{
	/////////////////////////////////////////////// INTERNAL VARIABLES ///////////////////////////////////////////////////////
	this.HOST_CONSTANT = "hostConstant";
	this.CONTROLLER_CONSTANT = "controllerConstant";
	this.ENCLOSURE_CONSTANT = "enclosureConstant";
	this.DISK_CONSTANT = "diskConstant";
	this.VOLUME_CONSTANT = "volumeConstant";
	this.POOL_CONSTANT = "poolConstant";
	
	this.LOCATE_JSP_PATH = "faces/page/allresources/Locate.jsp";
	
	
	// Uses the map object from common.js
	var map = new Map();
	
	// Specifies the type of device. possible values are: 'host', 'controller', 'enclosure', 'disk', 'volume', 'pool'. the constants can be found in the pagecode
	var locateType = "";
	
	// Specifies whether we are going to start or stop locating
	var locateAction = "";
	
	/////////////////////////////////////////////// SETTING UP ///////////////////////////////////////////////////////
	
	this.addResourceToLocate = function(id)
	{
		map.put(id, id);
	}
	
	this.removeResourceToLocate = function(id)
	{
		map.remove(id);
	}
	
	this.removeAllResourcesToLocate = function()
	{
		map.clear();
	}
	
	this.setLocateType = function(type)
	{
		// The passed constant will hold the id of the hiddden field that contains the constant used by the beans
		locateType = document.getElementById(type).value;
	}
	
	/////////////////////////////////////////////// START AND STOP ///////////////////////////////////////////////////////
	
	this.startLocate = function()
	{
		// Set the title to be the generic title
		locateObject.setLocateModalTitle(document.getElementById("defaultTitleConstant").value);
		locateObject.startLocateWait();
		locateAction = document.getElementById("startConstant").value;
		locateObject.removeFormChildren();
		locateObject.addParameter('locateAction', locateAction);
		locateObject.addParameter('locateDeviceType', locateType);
		
		var ids = map.getValues();
		for(var x = 0; x < ids.length; x++)
		{
			locateObject.addParameter('locateDeviceID', ids[x]);
		}
		
		// Launch the modal
		getElementByIdSuffix("locateSubview:locateLauncher", "input").click();
		// submit the form
		locateObject.submitForm();
	}
	
	this.stopLocate = function()
	{
		locateObject.startLocateWait();
		locateAction = document.getElementById("stopConstant").value;
		locateObject.removeFormChildren();
		locateObject.addParameter('locateAction', locateAction);
		locateObject.addParameter('locateDeviceType', locateType);
		
		var ids = map.getValues();
		for(var x = 0; x < ids.length; x++)
		{
			locateObject.addParameter('locateDeviceID', ids[x]);
		}
		
		locateObject.submitForm();
	}
	
	/////////////////////////////////////////////// HELPERS ///////////////////////////////////////////////////////
		
	this.startLocateWait = function()
	{
		// Show the wait div and hide the dynamic div
		document.getElementById('locateLoadingDiv').style.display='block'; 
		document.getElementById('locateDynamicDiv').style.visibility='hidden';
		
		// Make the dynamic frame very small
		document.getElementById('locateDynamicFrame').style.height = "1px";	
	}
	
	this.stopLocateWait = function()
	{	
		document.getElementById('locateLoadingDiv').style.display='none'; 
		document.getElementById('locateDynamicDiv').style.visibility='visible';
		
		resizeFrameHeight("locateDynamicFrame", "locateDynamicFrame");
	}
	
	this.setLocateModalTitle = function(newTitle)
	{
		//can not replace the title using innerHTML. otherwise the close icon link will be link to a certain page when click the close icon.
		$("view:locateSubview:locateModal_tb").lastChild.nodeValue = newTitle;
		$("view:locateSubview:locateModal_tb").title = newTitle;
	}
	
	this.closeLocateModal = function()
	{
		// Click the close button
		getElementByIdSuffix("locateSubview:hiddenStopLocatingButton", "input").click();
	}
	
	//the added parameter will be created as input hidden field in form.
	this.addParameter = function(name, value)
	{	
		var locateForm = $("locateForm");
		var input = document.createElement("input");
		input.type="hidden";
		input.name=name;
		input.id=name;
		input.value=value;
		locateForm.insertBefore(input,locateForm.lastChild);
	}
	
	//remove all the nodes in paneldialog_form
	this.removeFormChildren = function()
	{
		var locateForm = document.getElementById("locateForm");
		locateForm.innerHTML="";
	}
	
	//submit the locate form
	this.submitForm = function() 
	{
		var locateForm = document.getElementById("locateForm");
		locateForm.submit();
	}
	
	this.updateButtonValueToOK = function() {
		getElementByIdSuffix("locateSubview:stopLocatingButton", "input").style.display="none";
		getElementByIdSuffix("locateSubview:OKButton", "input").style.display="block";
	}
	
	this.updateButtonValueToStop = function(){
		getElementByIdSuffix("locateSubview:stopLocatingButton", "input").style.display="block";
		getElementByIdSuffix("locateSubview:OKButton", "input").style.display="none";
	}
}

var locateObject = new LocateObject();