<%-- jsf:pagecode language="java" location="/src/pagecode/page/allresources/RetryConnection.java" --%><%-- /jsf:pagecode --%>

<HTML>
<HEAD>
<%@ include file="/page/common/Header.jsp"%>
<BASE href="<%=basePath%>">

<%@ taglib uri="http://java.sun.com/jsf/html" prefix="h"%>
<%@ taglib uri="http://www.ibm.com/jsf/html_extended" prefix="hx"%>
<%@ taglib uri="http://java.sun.com/jsf/core" prefix="f"%>

<f:loadBundle basename="com.ibm.sysmgmt.scm.ar.nls.GWMARL" var="bundle" />
<%@page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
	
<META http-equiv="Content-Type" content="text/html; charset=UTF-8">
<META name="GENERATOR" content="IBM Software Development Platform">
<META http-equiv="Content-Style-Type" content="text/css">

<LINK rel="stylesheet" type="text/css" href="page/common/scmstyle.css"
	title="Style">

<SCRIPT type="text/javascript" src="page/common/common.js"></SCRIPT>
<SCRIPT type="text/javascript" src="page/allresources/RetryConnection.js"></SCRIPT>

</HEAD>
<f:view>
	<hx:scriptCollector id="scriptCollector" preRender="#{pc_RetryConnection.onPageLoadBegin}">
		<BODY>
			<div id="contentDiv">
			<h:form id="form1">
				<%@include file="/page/common/InlineMessagePlaceHolder.jsp"%>
<!-- ----------------------------------------- Instruction -------------------------------------- -->			
				<h:outputText id="retryConnectionInstructions" styleClass="scm_outputText"
				value="#{bundle.Retry_Connection_Instructions}"></h:outputText>
				
				<HR/>

<!-- ----------------------------------------- IP -------------------------------------- -->

			<h:outputText id="hostIPAddressLabel"
				styleClass="scm_outputTextTitle2"
				value="#{bundle.Retry_Connection_HostIPAddress}"></h:outputText>

			<BR>

			<div style="padding-left: 10px"><h:outputText
				id="hostIPAddressAsterix" styleClass="scm_outputText"
				style="color: red" value="#{bundle.Common_Asterix}"></h:outputText>

			<h:inputText id="hostIPAddressInput" value="#{retryConnectionBean.ip}" styleClass="scm_inputText"></h:inputText>

			<hx:graphicImageEx id="hostIpAddressHelpImage"
				value="images/expandcollapse/help_plus.gif" style="cursor: pointer"
				alt='#{bundle.Common_Collapsed}'
				title='#{bundle.Common_Collapsed}'
				tabindex="0" onkeyup="selfClick(this,event);"
				onclick="toggleExpandCollapse(this, 'images/expandcollapse/help_plus.gif', '#{bundle.Common_Collapsed}', 'images/expandcollapse/help_minus.gif', '#{bundle.Common_Expanded}', 'hostIPAddressHelpDiv');resizeDialog();">
			</hx:graphicImageEx>

			<h:outputLabel id="hostIPDescription" for="hostIPAddressInput" styleClass="scm_outputText"
				value="#{bundle.Retry_Connection_HostIPInstructions}"></h:outputLabel> <BR>

			<div id="hostIPAddressHelpDiv" style="display: none"><h:outputText
				id="hostIPHelpMessage" escape="false" styleClass="scm_outputText"
				value="#{bundle.Retry_Connection_HostIPHelpInstructions}"></h:outputText></div>
			</div>

			<div id="hostip_nullmessage_div"
				style="display:none; padding-left:24px;">
				<h:outputText id="hostip_null_message" styleClass="scm_outputTextError"
					value="#{bundle.Retry_Connection_Validation_IP_Null}">
				</h:outputText>
			</div>
			
			<div id="hostname_exceed_maxlength_div"
				style="display:none; padding-left:24px;">
				<h:outputText id="hostname_exceed_maxlength_message" styleClass="scm_outputTextError"
					value="#{bundle.Retry_Connection_Validation_DNS_Length_Exceed_MAX}">
				</h:outputText>
			</div>
			
			<div id="hostname_illegal_char_div"
				style="display:none; padding-left:24px;">
				<h:outputText id="hostname_illegal_char_message" styleClass="scm_outputTextError"
					value="#{bundle.Retry_Connection_Validation_DNS_Has_Illegal_Char}">
				</h:outputText>
			</div>
			<BR>


			<h:outputText id="hostLoginLabel" styleClass="scm_outputTextTitle2"
				value="#{bundle.Retry_Connection_HostLogin}"></h:outputText>

			<BR>

			<div style="padding-left: 10px"><h:outputText
				id="hostLoginDescription" styleClass="scm_outputText"
				value="#{bundle.Retry_Connection_HostLoginDescription}"></h:outputText> <BR>

			<table>
				<tbody>
					<tr>
						<td><h:outputText id="hostUseridAsterix"
							styleClass="scm_outputText" style="color: red"
							value="#{bundle.Common_Asterix}"></h:outputText> <h:outputLabel
							id="hostUseridLabel" for="hostUseridInput" styleClass="scm_outputText"
							value="#{bundle.Retry_Connection_UserID}"></h:outputLabel></td>
						<td><h:inputText id="hostUserIDInput"
							value="#{retryConnectionBean.userID}" styleClass="scm_inputText"></h:inputText></td>
					</tr>
					<tr id="userid_message_tr" style="display:none;">
						<td style="padding-left:13px">&nbsp;</td>
						<td><h:outputText id="userid_incorrect_message"
							styleClass="scm_outputTextError"
							value="#{bundle.Retry_Connection_Validation_UserID_Null}"></h:outputText>
						</td>
					</tr>
					<tr>
						<td><h:outputText id="hostPasswordAsterix"
							styleClass="scm_outputText" style="color: red"
							value="#{bundle.Common_Asterix}"></h:outputText> <h:outputLabel
							id="hostPasswordLabel" for="hostPasswordInput" styleClass="scm_outputText"
							value="#{bundle.Retry_Connection_Password}"></h:outputLabel></td>
						<td><h:inputSecret id="hostPasswordInput" styleClass="scm_pwdText"
							value="#{retryConnectionBean.password}"></h:inputSecret></td>
					</tr>
					<tr id="password_message_tr" style="display:none;">
						<td style="padding-left:13px">&nbsp;</td>
						<td><h:outputText id="password_incorrect_message"
							styleClass="scm_outputTextError"
							value="#{bundle.Retry_Connection_Validation_Password_Null}"></h:outputText>
						</td>
					</tr>
				</tbody>
			</table>

			</div>
		
		<BR/>
		
		<h:inputHidden id="oldIPInput" value="#{retryConnectionBean.oldIP}"></h:inputHidden>
		
		
		<h:commandButton type="submit" id="retryConnectionOK"
			value="#{bundle.Common_OK}" action="#{pc_RetryConnection.doOKBtn}"
			 styleClass="scm_button"  onclick="return onOKBtnClicked();">
		</h:commandButton>
		<h:commandButton type="button" id="retryConnectionCancel"
			value="#{bundle.Common_Cancel}" onclick="parent.panelDialogObj.closeDialog()" 
			 styleClass="scm_button">
		</h:commandButton>				
				
		</h:form>
		</div>
		
		<div id="waitingDiv" style="display:none">
			<TABLE>
				<TBODY>
				<TR>
					<TD>
						<img src="images\loading\loading_large.gif" alt=""></img>
					</TD>
					<TD>
						<h:outputText id="retryingText" styleClass="scm_outputText"  value="#{bundle.Retry_Connection_Indicator_Text}">
						</h:outputText>
					</TD>
				</TR>
				</TBODY>
			</TABLE>
		</div>
		
		<h:outputText id="retry_connection_dialog_title" value="#{retryConnectionBean.dialogTitle}" style="display:none"></h:outputText>
			
		</BODY>
		
		<jsp:include page="/page/common/InlineMessages.jsp"></jsp:include>
		
	</hx:scriptCollector>
</f:view>
<script language="javascript">
var title = $("view:retry_connection_dialog_title").innerHTML;
parent.panelDialogObj.setPanelDialogTitle("view", title);
</script>