// -------------------------------- Page Refresh ------------------------------
//updated by heming, the refresh method name duplicate with the same name method in AllResource.js
function commonRefresh()
{
	var currLocation = location.href;
	location.href = currLocation;
}

function getLocalizedCurrentTime()
{
	// datetimeFormatPattern is defined in Header.jsp
	var cvt = hX.getConverterById("ARCVT");
	if(null == cvt)
	{
		// decimalFormatPattern is defined in Header.jsp
		hX.addConverter("ARCVT", new hX.DateTimeConverter(datetimeFormatPattern, "ICU4J:true"));
	}
	var cvt = hX.getConverterById("ARCVT");
	var d = new Date();
	return cvt.valueToString(d);
}
// -------------------------------- Dom Operation -----------------------------
//Use this as a replacement for getElementById
function $(id)
{
	if(arguments.length>1)
	{
		var aResult=[];
		for(var i=0;i<arguments.length;i++)
		{
			aResult.push($(arguments[i]));
		}
		return aResult;
	}
	else
	{
		if(document.getElementById)
		{
			return document.getElementById(id);
		}
		else if(document.all)
		{
			return document.all[id];
		}
		return null;
	}
}

//find the first matched tag by its id suffix
//this function is intended for subview page use only, as these pages usually do not know its tag full id 
function getElementByIdSuffix(tagName, tagType)
{
	oTags = document.getElementsByTagName(tagType);
	for(var i=0; i< oTags.length; i++)
	{
		if(oTags[i].id.endWith(tagName))
		{
			return oTags[i];
		}
	}
	return null;
}

//return the deepest non-text child of a node
function getDeepestChild(node)
{
	while(node.nodeType == 1)
	{
		node = node.lastChild;
	}
	return node.parentNode;
}

//return the parent node of element with the tagName name
function getParentNodeByName(element,name)
{
	  if(element.parentNode)
	  {
		  if(element.parentNode.tagName.toUpperCase() == name.toUpperCase())
		  {
		    return element.parentNode;
		  }
		  else
		  {
		    return getParentNodeByName(element.parentNode,name);
		  }
  	   }
  	   else
  	   {
  	      return null;
  	   }
}

function selfClick(thisObject, thisEvent){
	var keyCode = thisEvent.keyCode;
	// Space's key code is 32.
	if (keyCode == 32) {
		thisObject.onclick();
	}
}

//add a hidden input at the end of the parent element
function attachHiddenInput(parent, name, value)
{
	var input = document.createElement("input");
	input.type="hidden";
	input.name=name;
	input.id=name;
	input.value=value;
	parent.insertBefore(input,parent.lastChild);
}

// ------------------------------- String Operation ---------------------------
//return true if the string ends up with subStr
String.prototype.endWith = function(subStr)
{
	if(subStr)
	{
		if(0 > this.lastIndexOf(subStr))
		{
			return false;
		}
		else
		{
			return this.lastIndexOf(subStr) + subStr.length == this.length;
		}
	}
	else
	{
		return false;
	}
}
// ------------------------------------ SHELLS --------------------------------

function startShellLoading()
{
	document.getElementById('dynamicDiv').style.visibility='hidden';
	
	// Make the dynamic frame very small
	document.getElementById('dynamicFrame').style.height = "1px";

	EventHandling.addEventHandler("load", document.getElementById('staticLoadingFrame'), onStaticFrameLoadingComplete, false);
	window.frames['staticLoadingFrame'].location.href = window.frames['staticLoadingFrame'].location.href;
}

function stopShellLoading()
{
	resizeFrameHeight("dynamicFrame", "dynamicFrame");

	document.getElementById('staticLoadingDiv').style.display='none'; 
	document.getElementById('dynamicDiv').style.visibility='visible';
}

function onStaticFrameLoadingComplete()
{
	var e = arguments[0];
	var target = EventHandling.getTargetElement(e);
	document.getElementById('staticLoadingDiv').style.display='block'; 
	resizeFrameHeight(target.id, target.name);	
}

// ------------------------------------ IFRAMES --------------------------------
function resizeFrameHeight(frameID, frameName)
{
	frameObject = document.getElementById(frameID);
	
	// No frame was found
	if(!frameObject)
	{
		return;
	}
	
	// Reset it to a small value so that the height is always increased
	frameObject.style.height = 1;
	
	frameDocument = window.frames[frameName].document;
	
	frameBody = frameDocument.body;

	// Calculate content height
	oHeight = 0;
	sHeight = 0;
	
	if(frameBody.offsetHeight)
		oHeight = frameBody.offsetHeight;
	
	if(frameBody.scrollHeight)
		sHeight = frameBody.scrollHeight;
		
	// Set the height to the bigger one
	newHeight = Math.max(oHeight, sHeight);
	
	//add a buffer size
	newHeight+=5;
	
	frameObject.style.height = String(newHeight) + "px";
}

function bringMeTop()
{
	var parentDom = parent;
	var childDom = self;
	if(parentDom != self)
	{
		while(parentDom && parentDom.$ && parentDom.parent && parentDom.parent.$)
		{
			childDom = parentDom;
			parentDom = parentDom.parent;
		}
	}
	if(childDom != self)
	{
		childDom.location.href = self.location.href;
	}
}

//resize all of the ancestor frames.
function resizeAncestorFrame()
{
	var parentObj = parent;
	var currentObj = self;
	var currentDocument = document;
	//if there is no parent frame, the parent equals self.
	try
	{
		while(parentObj != currentObj) {
			if (parentObj.frames && parentObj.frames.length > 0 && parentObj.$) {
				var parentFrames = parentObj.frames;
				for (var i = 0; i < parentFrames.length; i++) {
					var isEnclosingFrame = false;
					if(isIE())
					{
						if(currentDocument.parentWindow == parentFrames[i])
						{
							isEnclosingFrame = true;
						}
					}
					else
					{
						  if(parentFrames[i].document == currentDocument)
						  {
						  		isEnclosingFrame = true;
						  }
					}
					if(true == isEnclosingFrame)
					{
						  	parentObj.resizeFrameHeight(parentFrames[i].name,parentFrames[i].name);
							currentDocument = parentObj.document;
							currentObj = parentObj;
							parentObj = parentObj.parent;
							break;
					}
				}
			}else{
				break;
			}
		}
	}
	//IE sometimes has restriction for cross-frame document access.
	//Therefore, if it fails to loop to top parent, just do nothing.
	catch(e)
	{
	}
}
// ------------------------------------- Tabbed Panel -------------------------
//count: the count of tabs
//prefix: the id prefix concatenated by jwl 
TabbedPanel.BLANK = "images/status/normal_16.gif";

function TabbedPanel(count, prefix)
{
	var tabCount = count;
	var idPrefix = prefix;
	
	var statusImgMap = new Array;
	//dummy value here, as the array is zero based
	statusImgMap[0] = "";
	for(var i = 1; i <= tabCount; i++)
	{
		statusImgMap[i] = TabbedPanel.BLANK;
	}
	
	//tabIndex: the index of the tab, based on 1
	//statusImgPath: the image path of the status icon
	this.setTabStatus = function(tabIndex, statusImgPath)
	{
		if("" != statusImgPath)
		{
			var tabName = idPrefix + ":" + "tabbedPanelscm_tabbedPanel_toptablabel_" + tabIndex;
			var oTab = $(tabName);
			var oImages = oTab.getElementsByTagName("img");
			oImages[0].src = basePath + statusImgPath;
			if(statusImgPath == TabbedPanel.BLANK)
			{
				oImages[0].style.display = "none;"
			}
			else
			{
				oImages[0].style.width = "16px";
				oImages[0].style.height = "16px";
				oImages[0].style.display = "inline";
			}
			//if the code can proceed here, it mean the tabIndex and status code are both valid
			statusImgMap[tabIndex] = statusImgPath;
		}
	}
	
	//redraw the status images in all tabs
	this.redrawTabStatusImage = function()
	{
		for(var i = 0; i < statusImgMap.length; i++)
		{
			this.setTabStatus(i, statusImgMap[i]);
		}
	}
}

// ------------------------------------- Event handling -------------------------
function EventHandling()
{
}

EventHandling.addEventHandler = function(event, target, handler, useCapture){
	// DOM Level 2 event model
	if (target.addEventListener) { 
		// Register capturing event handlers
		target.addEventListener(event, handler, useCapture);
	}
	// IE 5+ Event Model
	else if (target.attachEvent) {
		target.attachEvent("on" + event, handler);
	}
}

EventHandling.getTargetElement = function(e)
{
	var elem;
	if(e.target)
	{
		//if node type is text, return the parent node instead
		elem = (e.target.nodeType==3) ? e.target.parentNode : e.target;//FF
	}else{
		elem = e.srcElement;//IE
	}
	return elem;
}

EventHandling.stopBubble = function(e)
{
	if (e.target) { 
		//FF
		e.stopPropagation();
	}else{
		//IE
		e.cancelBubble = true;
	}
}

EventHandling.preventReturnValue = function(e)
{
	if (e.target) { 
		//FF
		e.preventDefault();
	}else{
		//IE
		e.returnValue = false;
	}	
} 


// ---------------------------------------  Map ------------------------------------
//entry for the map
function MapEntry(k,v)
{
    this.k = k;
    this.v = v;
}
//this code simulates Map in Java
function Map()
{
    var m = new Array();
    
    //put a key/value pair in map
    this.put = function(k, v)
    {
        var newEntry = new MapEntry(k,v);
        for(i in m)
        {
            if(newEntry.k == m[i].k)
            {
                m[i] = newEntry;
                return;
            }
        }
        m.push(newEntry);        
    }
    
    //get value by key
    this.get = function(k)
    {
        for(i in m)
        {
            var entry = m[i];
            if(entry.k == k)
            {
                return entry.v;
            }
        }
        return null;
    }
    
    //remove an entry by key
    this.remove = function(k)
    {
        var entryPoped;
        for(i in m)
        {
            entryPoped = m.pop();
            if(entryPoped.k == k)
            {
                break;
            }
            else
            {
                m.unshift(entryPoped);
            }
        }
    }
	
    //return map size
    this.getSize = function()
    {
        return m.length;
    }
    
    //get all the values in map
    this.getValues = function()
    {
        var values = new Array();
        for(i in m)
        {
            values.push(m[i].v);
        }
        return values;
    }
    
    this.getKeys = function()
    {
    	var keys = new Array();
    	for(i in m)
    	{
    		keys.push(m[i].k);
    	}
    	return keys;
    }
    
    //removes all values from the map
    this.clear = function()
    {
    	m.length = 0;
    }
}

// ---------------------------------------- MENU ----------------------------------

function disableMenuItem(menu, id)
{
	// If this item was selected, clear the selection
	idInMenu = menu.getMenuItemById(id);
	
	if(menu.getValue() == idInMenu)
	{
		menu.setValue("");
	}
	
	menuItem = getMenuItemById(menu, id);
	menuItem.setAttribute("disabled:true");
}

function enableMenuItem(menu, id)
{
	menuItem = getMenuItemById(menu, id);
	menuItem.setAttribute("disabled:false");
}

function getMenuItemById(menu, id)
{
	idInMenu = menu.getMenuItemById(id);
	
	return getMenuItemByIdHelper(menu, idInMenu);
}

function getMenuItemByIdHelper(menu, idInMenu)
{
	// If this is not a menu, then return
	if(menu.id == idInMenu)
	{
		return menu;
	}
	
	// Try to recurse
	var menuItems = menu.m.itemArray;
	
	for(var x = 0; x < menuItems.length; x++)
	{		
		// See if its in a submenu of the current item
		var recursiveResult = getMenuItemByIdHelper(menuItems[x], idInMenu);
		
		if(recursiveResult != null)
		{
			return recursiveResult;
		}
	}
	
	return null;
}

// ------------------------------------ EXPAND/COLLAPSE --------------------------------
// Used by collapsable sections, such as expand-help to toggle the visbility of a section
function toggleExpandCollapse(image, collapsedImagePath, collapsedImageAlt, expandedImagePath, expandedImageAlt, contentId, useVisibility)
{
	// Check for the content being visible
	content = document.getElementById(contentId);
	
	if(content)
	{
		if(useVisibility)
		{
			if(content.style.visibility == "hidden")
			{
				// The section is collapsed, expand it
				
				content.style.visibility = "visible";
				
				image.src = expandedImagePath;
				image.alt = expandedImageAlt;
				image.title = expandedImageAlt;
			}
			else
			{
				content.style.visibility = "hidden";
			
				image.src = collapsedImagePath;
				image.alt = collapsedImageAlt;
				image.title = collapsedImageAlt;
			}
		}
		else
		{
			if(content.style.display == "none")
			{
				// The section is collapsed, expand it
				
				content.style.display = "block";
				
				image.src = expandedImagePath;
				image.alt = expandedImageAlt;
				image.title = expandedImageAlt;
			}
			else
			{
				// The section is expanded, collapse it
				
				content.style.display = "none";
				
				image.src = collapsedImagePath;
				image.alt = collapsedImageAlt;
				image.title = collapsedImageAlt;
			}
		}
		
		// If this page is part of a dymanic frame in a shell, resize the frames
		if(parent && parent.window.frames["dynamicFrame"])
		{
			parent.resizeFrameHeight("dynamicFrame", "dynamicFrame");
		}
	}
}

// ------------------------------------ JSON Operations --------------------------------
//this is a class for json operation
//it is a static class, there is no need to initialize it for use, like JSON.strinify(jsonObject)
JSON = function ()
{
	return {
		//use this method convert a javascript built in json object into a string presentation
		stringify : function(value)
		{
			return toStr(value);
		},
		//use this method to parse a json text into a json object
		parse : function(str)
		{
			return eval('(' + str + ')');
		}
	}
	
	function isArray(value)
	{
		if(value[0])
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	function isObject(value)
	{
		if("object" == typeof value)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	function toStr(value)
	{
		var strValue = "";
		if(isObject(value))
		{
			if(isArray(value))
			{
				strValue += "[";
				for(i in value)
				{
					strValue += toStr(value[i]);
					strValue += ",";
				}
				strValue = strValue.substr(0, strValue.length - 1);
				strValue += "]";
			}
			else
			{
				strValue += "{";
				for(i in value)
				{
					strValue += i;
					strValue += ":";
					strValue += toStr(value[i]);
					strValue += ",";
				}
				strValue = strValue.substr(0, strValue.length - 1);
				strValue += "}"
			}
		}
		else
		{
			if("string" == typeof value)
			{
				strValue = '"' + value + '"';
			}
			else
			{
				strValue = value;
			}
		}
		return strValue;
	}
}();	

// -------------------------------- Disable Inputs when posting page -------------------------	
//show waiting cursor and set inputs disable
function showWaitCursor(showWaitCursor) {
	if(showWaitCursor)
	{
		document.body.style.cursor='wait';
	}
	window.setTimeout(disableAllInputs,200);
    return true;
}

//disable all the page inputs
function disableAllInputs()
{
	var oInputs = getAllInputs();
	for(var i = 0; i < oInputs.length; i++)
	{
		try
		{
			oInputs[i].disabled = true;
		}
		catch(e){}
	}
	disableAnchors();
}

//disable all the anchors
function disableAnchors()
{
	var anchors = document.getElementsByTagName("a");
	for(var i = 0; i < anchors.length; i++)
	{
		var href = anchors[i].getAttribute("href");
		if(href && href != "")
		{
			anchors[i].removeAttribute("href");
		}
	}
}

//get all the page inputs by tagname
function getAllInputs()
{
	var oRet = new Array;
	var oTemp = new Array;
	var inputTagNames = ["Input","Select","Button"];
	for(var i = 0; i < inputTagNames.length; i++)
	{
		oTemp = document.getElementsByTagName(inputTagNames[i]);
		if(oTemp.length > 0)
		{
			for(var j = 0; j < oTemp.length; j++)
			{
				oRet.push(oTemp[j]);
			}
		}
	}
	return oRet;
}


// -------------------------------- Characters Validation  -------------------------	
//check the value is numerical characters or not.
function isNumber(val)
{
	var regex = /\d+/;  //equals to /[0-9]+/
	if(val == regex.exec(val))
	{
		return true;
	}else{
		return false;
	}
}

//allows positive integers, negative integers and 0
function isInteger(val)
{
	var regex = /^[-]?[1-9]\d*|0$/;
	if(val == regex.exec(val))
	{
		return true;
	}else{
		return false;
	}
}


// ---------------------------- AJAX --------------------------------------
function getXmlHttpObject()
{
	var result = null;
	
	try
	{
		// Non IE
		result = new XMLHttpRequest();
	}
	catch (e)
	{
	  // IE
	  try
	  {
	  	result = new ActiveXObject("Msxml2.XMLHTTP");
	  }
	  catch (e)
	  {
	  	result = new ActiveXObject("Microsoft.XMLHTTP");
	  }
	}
	
	return result;
}

//--------------------------Browser------------------------------------------
function isIE()
{
	var ua = navigator.userAgent.toLowerCase();
	return (ua.match(/msie ([\d\.]+)/)) ? true : false;
}
//------------------------------Decimal Format-------------------------------
function formatDecimal(value)
{
	var cvt = hX.getConverterById("ARDCVT");
	if(null == cvt)
	{
		// decimalFormatPattern is defined in Header.jsp
		hX.addConverter("ARDCVT", new hX.NumberConverter(decimalFormatPattern, decimalFormatSymbols, "ICU4J:true"));
	}
	cvt = hX.getConverterById("ARDCVT");
	var output = cvt.valueToString(value);

	//JWL NumberConventor leaves decimal separator whe nformatting a number without fraction
	if(output.endWith(decimalSeparatorSymbol))
	{
		output = output.replace(new RegExp("\\" + decimalSeparatorSymbol + "*$"), "");
	}
	return output;
}

function parseDecimal(string)
{
	var cvt = hX.getConverterById("ARDCVT");
	if(null == cvt)
	{
		// decimalFormatPattern is defined in Header.jsp
		hX.addConverter("ARDCVT", new hX.NumberConverter(decimalFormatPattern, decimalFormatSymbols, "ICU4J:true"));
	}
	cvt = hX.getConverterById("ARDCVT");
	return cvt.stringToValue(string);
}

//------------------------- URL ---------------------------------------------
function getQueryVariable(variable) 
{
	var query = window.location.search.substring(1);
	var vars = query.split("&");
	for(var i = 0; i < vars.length; i++) 
    {
		var pair = vars[i].split("=");
		if (pair[0] == variable) 
		{
			return pair[1];
		}
	}
	return null;
}
//-------------------------Beep After Refresh----------------------------------
//add alert user when ajax complete

//beep when the switch is open
function beepWhenRefresh() {
	if (alertUserWhenAJAXCompletes) {
       	beep();
   	}
}

// beep once
function beep() {
    try
    {
		if (!isIE()) {
			if (navigator.javaEnabled != null && navigator.javaEnabled()) {
				java.awt.Toolkit.getDefaultToolkit().beep();
			}
		} else {
			var beepobj = document.getElementById("beepid");
			if (beepobj != null && typeof(beepobj.Play) != "undefined") {
				beepobj.Play();
			}
		}
	}catch(e){}	
}