// --------------------------------------- PROPERTIES ---------------------------

var CONTROLLER_PROPERTIES_DIALOG_PATH = "faces/page/allresources/ControllerProperties.jsp";
var HOST_PROPERTIES_DIALOG_PATH = "faces/page/allresources/HostProperties.jsp";

function showControllerProperties(id)
{
	//set title
	var title = $("view:form1:controller_dialog_title").innerHTML;
	panelDialogObj.setPanelDialogTitle("view", title);
	var action = CONTROLLER_PROPERTIES_DIALOG_PATH;
	panelDialogObj.addParameter("controller_id", id);
	panelDialogObj.launchDialogPOST("view",action,'620');
}

function showHostProperties(id)
{
	//set title
	var title = $("view:form1:host_dialog_title").innerHTML;
	panelDialogObj.setPanelDialogTitle("view", title);
	var action = HOST_PROPERTIES_DIALOG_PATH;
	panelDialogObj.addParameter("host_id", id);
	panelDialogObj.launchDialogPOST("view",action,'620');
}


function showBBUProperties(id)
{
	// Set the controller id in the object
	bbuPropertiesObject.setControllerID(id);
	
	// Launch the modal
	bbuPropertiesObject.launchModal();
}

// --------------------------------------- PROPERTIES ---------------------------
var frameworkObj = new PhysicalFramework();

function PhysicalFramework()
{
	var physicalTab = new TabbedPanel(2, "view:form1");
	
	var diskTabPage = "faces/page/storage/DiskDrivesView.jsp?parent=physical";
	var enclosureTabPage = "faces/page/physical/EnclosuresView.jsp";
	
	var diskReload = false;
	var enclosureReload = false;
	
	this.initFrame = function()
	{
		var previousSelectedTab = parent.previousSelectedTabObj.getPreviousSelectedTab();
		if(previousSelectedTab != null && previousSelectedTab != "")
		{
			ODCTabPanelControlVar1.restoreUIState(previousSelectedTab);
			switch(previousSelectedTab)
			{
				case parent.PreviousSelectedTab.PHYSICAL_TAB_ENCLOSURE:
					$("enclosure_iframe").src = basePath + enclosureTabPage;
					break;
					
				case parent.PreviousSelectedTab.PHYSICAL_TAB_DISK:
					$("disk_iframe").src = basePath + diskTabPage;
					break;
			}
		}else{
			$("disk_iframe").src = basePath + diskTabPage;
		}
	}
	
	this.onTabEnter = function(thisObj, thisEvent)
	{
		var panelId = thisEvent.tobeEnterPanel;
		var objFrame;
		
		if(panelId.endWith("disk_tab"))
		{
			if(diskReload == true || !$("disk_iframe").src.endWith(diskTabPage))
			{
				$("disk_iframe").src = basePath + diskTabPage;
				diskReload = false;
			}else{
				if($("disk_iframe").contentWindow.loaded == true)
				{
					setTimeout("$('disk_iframe').contentWindow.stopShellLoading();", 50);
					setTimeout("$('disk_iframe').contentWindow.$('dynamicFrame').contentWindow.dataTableObj.initHeaderDivPaddingWidth('view:form1:diskdrives_table');", 200);
				}
			}
		}
		else if(panelId.endWith("enclosure_tab"))
		{
			if(enclosureReload == true || !$("enclosure_iframe").src.endWith(enclosureTabPage))
			{
				$("enclosure_iframe").src = basePath + enclosureTabPage;
				enclosureReload = false;
			}else{
				if($("enclosure_iframe").contentWindow.loaded == true)
				{
					setTimeout("$('enclosure_iframe').contentWindow.stopShellLoading();", 50);
					setTimeout("$('enclosure_iframe').contentWindow.$('dynamicFrame').contentWindow.dataTableObj.initHeaderDivPaddingWidth('enclosuresTable');", 200);
				}
			}
		}
		
		//redraw();
	}
	
	this.setTabStatusImage = function(tabIndex, statusCode)
	{
		physicalTab.setTabStatus(tabIndex, statusCode);
	}
	
	this.redrawTabs = function()
	{
		physicalTab.redrawTabStatusImage();
	}
	
	this.setDiskReload = function(flag)
	{
		diskReload = flag;
	}
	
	this.setEnclosureReload = function(flag)
	{
		enclosureReload = flag;
	}
}


function redraw()
{
	//redraw tab image after odc client code has refresh it
	setTimeout("frameworkObj.redrawTabs();", 50);
}

