<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<%-- jsf:pagecode language="java" location="/src/pagecode/page/physical/PhysicalResources.java" --%><%-- /jsf:pagecode --%>
<HTML lang="<%=MessageFormatter.getCurrentLocaleString()%>">
<HEAD>

<%@ include file="/page/common/Header.jsp"%>
<BASE href="<%=basePath%>">

<%@ taglib uri="http://java.sun.com/jsf/html" prefix="h"%>
<%@ taglib uri="http://www.ibm.com/jsf/html_extended" prefix="hx"%>
<%@ taglib uri="http://java.sun.com/jsf/core" prefix="f"%>
<%@taglib uri="http://www.ibm.com/jsf/BrowserFramework" prefix="odc"%>

<f:loadBundle basename="com.ibm.sysmgmt.scm.ar.nls.GWMARL" var="bundle" />

<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="com.ibm.sysmgmt.scm.ar.nls.MessageFormatter,com.ibm.sysmgmt.scm.ar.nls.GWMARL" %>
<META http-equiv="Content-Type" content="text/html; charset=UTF-8">
<META name="GENERATOR" content="IBM Software Development Platform">
<META http-equiv="Content-Style-Type" content="text/css">

<LINK rel="stylesheet" type="text/css" href="page/common/scmstyle.css" title="Style">

<SCRIPT type="text/javascript" src="page/common/common.js"></SCRIPT>
<SCRIPT type="text/javascript" src="page/physical/PhysicalResources.js"></SCRIPT>

<TITLE>Physical Resources</TITLE>

</HEAD>
<f:view>
		<BODY onload="frameworkObj.initFrame();">
		
		<hx:scriptCollector id="scriptCollector" preRender="#{pc_PhysicalResources.onPageLoadBegin}">
		
		<jsp:include flush="true" page="/page/common/InlineMessagesAjax.jsp"></jsp:include>
		<jsp:include page="/page/common/ContextChooser.jsp"></jsp:include>
		
		<br/>
		
		<%-- ***************COMMON PANEL DIALOG must include it out of the <h:form/> tag ****************** --%>
		<jsp:include flush="true" page="/page/common/PanelDialog.jsp">
		</jsp:include>
		
		<jsp:include page="/page/physical/BBUPropertiesShell.jsp"></jsp:include>
		
		<h:form id="form1" target="_parent" rendered="#{!pc_PhysicalResources.responseComplete}">
		
		<!-- ------------------------------- PROPERTY LINKS ------------------------------------------ -->
		
		<table>
			<tr>
				<td>
					<h:graphicImage id="hostImage" value="images/components/host_small.gif" alt="#{bundle.Physical_Host_Alt}"></h:graphicImage>
				</td>
				<td>
					<h:inputHidden id="hostID" value="#{physicalResourcesBean.host.ID}"></h:inputHidden>
					
					<hx:outputLinkEx id="link_host" value="javascript:;"
							onclick="showHostProperties(document.getElementById('view:form1:hostID').value);"
							title="#{bundle.PhysicalResources_Host_LinkTitle}"
							styleClass="scm_plainLink">
							<h:outputText id="hostname" styleClass="scm_outputText" value="#{physicalResourcesBean.host.displayName}"></h:outputText>
					</hx:outputLinkEx>
				</td>
				<td style="padding-left: 20px;">
					<h:graphicImage id="hostStatusImage" value="#{physicalResourcesBean.host.statusImage}" alt="" style="vertical-align: middle"></h:graphicImage>
					
					<h:outputText id="hostStatusText" styleClass="scm_outputText" value="#{physicalResourcesBean.host.statusText}"></h:outputText>
				</td>
			</tr>
			<tr>
				<td>
					<h:graphicImage id="controlerImage" value="images/components/controller_small.gif" alt="#{bundle.Physical_Controller_Alt}"></h:graphicImage>
				</td>
				<td>
					<h:inputHidden id="controllerID" value="#{physicalResourcesBean.controller.ID}"></h:inputHidden>
					
					<hx:outputLinkEx id="link_controller" value="javascript:;"
							onclick="showControllerProperties(document.getElementById('view:form1:controllerID').value);"
							title="#{bundle.PhysicalResources_Controller_LinkTitle}"
							styleClass="scm_plainLink">
							<h:outputText id="controllerDispalyName" styleClass="scm_outputText" value="#{physicalResourcesBean.controller.displayName}"></h:outputText>
					</hx:outputLinkEx>
				</td>
				<td style="padding-left: 20px;">
					<h:graphicImage id="controllerStatusImage" value="#{physicalResourcesBean.controller.statusImage}" alt="" style="vertical-align: middle"></h:graphicImage>
					
					<h:outputText id="controllerStatusText" styleClass="scm_outputText" value="#{physicalResourcesBean.controller.statusText}"></h:outputText>
				</td>
			</tr>
			<tr>
				<td>
					<h:graphicImage id="bbuImage" value="images/components/battery_small.gif" alt="#{bundle.Physical_BBU_Alt}"></h:graphicImage>
				</td>
				<td>
					<hx:jspPanel id="bbuNamePanel" rendered="#{physicalResourcesBean.hasBBU}">
						<hx:outputLinkEx id="link_bbu" value="javascript:;"
							onclick="showBBUProperties(document.getElementById('view:form1:controllerID').value);"
							title="#{bundle.PhysicalResources_BBU_LinkTitle}"
							styleClass="scm_plainLink">
							<h:outputText id="bbuDisplayName" styleClass="scm_outputText" value="#{physicalResourcesBean.BBU.displayName}"></h:outputText>
						</hx:outputLinkEx>
					</hx:jspPanel>
					
					<h:outputText id="noBBUName" styleClass="scm_outputText" rendered="#{!physicalResourcesBean.hasBBU}" value="#{bundle.PhysicalResources_BBU}"></h:outputText>
				</td>
				<td style="padding-left: 20px;">
					<h:graphicImage  id="bbuStatusImage" rendered="#{physicalResourcesBean.hasBBU}" value="#{physicalResourcesBean.BBU.statusImage}" alt="" style="vertical-align: middle"></h:graphicImage>
					
					<h:outputText id="bbuStatusText" styleClass="scm_outputText" rendered="#{physicalResourcesBean.hasBBU}" value="#{physicalResourcesBean.BBU.statusText}"></h:outputText>
					
					<!-- In case there is no BBU installed -->
					<h:outputText id="bbuNotIstalled" styleClass="scm_outputText" rendered="#{!physicalResourcesBean.hasBBU}" value="#{bundle.PhysicalResources_BBUNotInstalled}"></h:outputText>
				</td>
			</tr>
		</table>
		
		<br/>
		
		<!-- ------------------------------- TABBED PANELS ------------------------------------------ -->
		
		<odc:tabbedPanel id="physical_tab_panel" styleClass="scm_tabbedPanel_top" width="100%" variableTabLength="true" showBackNextButton="false" showTabs="true" height="530">
			
			<odc:bfPanel id="disk_tab" name="#{bundle.Storage_Tab_Drives}" showFinishCancelButton="false" tabIcon="images/status/blank.gif" onenter="frameworkObj.onTabEnter(this, event)">
				<iframe id="disk_iframe" name="disk_iframe" title="<%=MessageFormatter.formatLabel(GWMARL.Disk_Iframe_Title, null)%>" src="" width="100%" scrolling="no" frameborder="0" style="height:500px">
				</iframe>
			</odc:bfPanel>
			
			<odc:bfPanel id="enclosure_tab" name="#{bundle.Physical_Tab_Enclosures}" showFinishCancelButton="false" tabIcon="images/status/blank.gif" onenter="frameworkObj.onTabEnter(this, event)">
				<iframe id="enclosure_iframe" name="enclosure_iframe" title="<%=MessageFormatter.formatLabel(GWMARL.Enclosure_Iframe_Title, null)%>" src="" width="100%" scrolling="no" frameborder="0" style="height:500px">
				</iframe>
			</odc:bfPanel>
			
			<f:facet name="back">
				<hx:commandExButton type="submit" value="&lt; Back"
					id="tabbedPanel_back" style="display:none"></hx:commandExButton>
			</f:facet>
			<f:facet name="next">
				<hx:commandExButton type="submit" value="Next &gt;"
					id="tabbedPanel_next" style="display:none"></hx:commandExButton>
			</f:facet>
			<f:facet name="finish">
				<hx:commandExButton type="submit" value="Finish"
					id="tabbedPanel_finish" style="display:none"></hx:commandExButton>
			</f:facet>
			<f:facet name="cancel">
				<hx:commandExButton type="submit" value="Cancel"
					id="tabbedPanel1sscancel" style="display:none"></hx:commandExButton>
			</f:facet>
		</odc:tabbedPanel>
		
		<h:outputText id="controller_dialog_title" value="#{bundle.ControllerProperties_Title_Default}" style="display:none"></h:outputText>
		<h:outputText id="host_dialog_title" value="#{bundle.HostProperties_Title_Default}" style="display:none"></h:outputText>
		
		</h:form>
		
		</hx:scriptCollector>
		</BODY>
</f:view>

</HTML>
