var diskDrivesObj = new DiskDrives();

DiskDrives.VIEW_ID = "view";
DiskDrives.VIEW_FORM_ID = "view:form1";
DiskDrives.DISKDRIVE_PROPERTIES_DIALOG_PATH = "faces/page/storage/DiskDriveProperties.jsp";
DiskDrives.DISKDRIVE_INITIALIZE_DIALOG_PATH = "faces/page/storage/InitializeDrivesConfirmation.jsp";

//disk drive states constants
DiskDrives.DISKDRIVE_STATE_UNCONFIGURED = 0;
DiskDrives.DISKDRIVE_STATE_CONFIGURED = 1;
DiskDrives.DISKDRIVE_STATE_DEDICATED = 2;
DiskDrives.DISKDRIVE_STATE_GLOBAL = 3;
DiskDrives.DISKDRIVE_STATE_FOREIGN = 4;

function DiskDrives()
{	
	var internal_location;
	var actionMenu;
	
	this.init = function()
	{
		actionMenu = hX_5.getComponentById(DiskDrives.VIEW_FORM_ID+":actionmenu");
		
		refreshTimestamp();
		changeLocateDriveBtn(true);//disable locate drive button
		changeAssignGlobalSpareBtn(true);//disable assign global spare button
		internal_location = $(DiskDrives.VIEW_ID+":internal_location").innerHTML;
		//if there is no foreign drives, disable the "clear foreign configuration" menu
		if(isForeignDrivesExist())
		{
			enableClearForeignCfItem();
		}
		
	};
	
	/*
		enable all disabled menus when click the checkbox button
	*/
	this.changeMenus = function()
	{
		var isRowSelected = dataTableObj.isRowSelected();
		var menuAttr = "";
		var flag = "";
		if(true == isRowSelected)
		{
			menuAttr = "disabled:false";
			flag = false;
		}
		else
		{
			menuAttr = "disabled:true";
			flag = true;
		}
		//properties menu
		var propertiesItem = actionMenu.getMenuItemById(DiskDrives.VIEW_FORM_ID+":properties_link");
		//assign global hot spare
		var assignGlobalSpareItem = actionMenu.getMenuItemById(DiskDrives.VIEW_FORM_ID+":assign_globalspare_link");
		//assign dedicated spare.  it's has been defered
		//var assignDedicatedSpareItem = actionMenu.getMenuItemById(DiskDrives.VIEW_FORM_ID+":assign_dedicatedspare_link");
		//unassign a hot spare.  it's has been defered
		var unassignGlobalSpareItem = actionMenu.getMenuItemById(DiskDrives.VIEW_FORM_ID+":unassign_globalspare_link");
		//create storage pool
		var createStoragePoolItem = actionMenu.getMenuItemById(DiskDrives.VIEW_FORM_ID+":create_storagepool_link");
		//locate drive
		var locateDriveItem = actionMenu.getMenuItemById(DiskDrives.VIEW_FORM_ID+":locatedrive_link");
		//initialize drive
		var initializeItem = actionMenu.getMenuItemById(DiskDrives.VIEW_FORM_ID+":initialize_link");
		
		
		var selectedRowCount = dataTableObj.getSelectedRowCount();
		if(selectedRowCount > 1)
		{
			hX_5.getSubComponentById(propertiesItem).setAttribute("disabled:true");
			$(DiskDrives.VIEW_FORM_ID+":properties_link").onclick="";
		}else{
			hX_5.getSubComponentById(propertiesItem).setAttribute(menuAttr);
			if(menuAttr == "disabled:false")
			{
				$(DiskDrives.VIEW_FORM_ID+":properties_link").onclick=diskDrivesObj.onClickPropertiesMenu;
			}else{
				$(DiskDrives.VIEW_FORM_ID+":properties_link").onclick="";
			}
			
		}
		//if there is no non-internal rows selected, disable locate drive menu, otherewise enable it.
		if(isRowSelected)
		{
			hX_5.getSubComponentById(locateDriveItem).setAttribute("disabled:false");
			changeLocateDriveBtn(false);
			$(DiskDrives.VIEW_FORM_ID+":locatedrive_link").onclick=diskDrivesObj.onClickLocateDrivesMenu;
			
			//if selected drives are all unconfigured or dedicated spared, enable the assgin global spare button. 
			if(isAllForAssignGHSDrivesSelected())
			{
				hX_5.getSubComponentById(assignGlobalSpareItem).setAttribute("disabled:false");
				changeAssignGlobalSpareBtn(false);
				$(DiskDrives.VIEW_FORM_ID+":assign_globalspare_link").onclick=diskDrivesObj.onClickAssignGHSMenuBtn;
			}else{
				hX_5.getSubComponentById(assignGlobalSpareItem).setAttribute("disabled:true");
				changeAssignGlobalSpareBtn(true);
				$(DiskDrives.VIEW_FORM_ID+":assign_globalspare_link").onclick="";
			}
			//unassign global spare
			if(isAllForUnassignGHSDrivesSelected())
			{
				hX_5.getSubComponentById(unassignGlobalSpareItem).setAttribute("disabled:false");
				$(DiskDrives.VIEW_FORM_ID+":unassign_globalspare_link").onclick=diskDrivesObj.onClickUnassignGHSMenu;
			}else{
				hX_5.getSubComponentById(unassignGlobalSpareItem).setAttribute("disabled:true");
				$(DiskDrives.VIEW_FORM_ID+":unassign_globalspare_link").onclick="";
			}
			
			//if selected drives are all unconfigured, enable the initialize menu.
			if(isAllUnconfiguredDrivesSelected())
			{
				hX_5.getSubComponentById(initializeItem).setAttribute("disabled:false");
				$(DiskDrives.VIEW_FORM_ID+":initialize_link").onclick=diskDrivesObj.onClickInitializeMenu;
			}else{
				hX_5.getSubComponentById(initializeItem).setAttribute("disabled:true");
				$(DiskDrives.VIEW_FORM_ID+":initialize_link").onclick="";
			}
			
		}else{
			hX_5.getSubComponentById(locateDriveItem).setAttribute("disabled:true");
			changeLocateDriveBtn(true);
			hX_5.getSubComponentById(assignGlobalSpareItem).setAttribute("disabled:true");
			changeAssignGlobalSpareBtn(true);
			hX_5.getSubComponentById(unassignGlobalSpareItem).setAttribute("disabled:true");
			hX_5.getSubComponentById(initializeItem).setAttribute("disabled:true");
			
		}
		
	};
	
	
	this.onClickClearForeignCfMenu = function()
	{
		//open the dialog
		$(DiskDrives.VIEW_FORM_ID+":clear_foreigncf_launcher").click();
	}
	
	this.onClickLocateDrivesMenu = function()
	{
		launchLocateDialog();
	};
	
	this.onClickLocateDrivesBtn = function()
	{
		launchLocateDialog();
	};
	
	//initialize
	this.onClickInitializeMenu = function()
	{
		//open the initialize confirmation dialog
		var drive_ids = dataTableObj.getSelectedIds();
		launchInitializeDialog(drive_ids);
	}

	
	//listener for the disk drive name link click event.
	this.onClickDiskDriveLink = function(thisObj)
	{
		//check the hidden radio button
		var oRow = thisObj.parentNode.parentNode.parentNode;
		var diskDriveId = oRow.cells[0].getElementsByTagName("input")[1].value;
		launchPropertiesDialog(diskDriveId);
	};

	//listener for the properties menu click event
	this.onClickPropertiesMenu = function()
	{
		var diskDriveId = dataTableObj.getSelectedIds();
		launchPropertiesDialog(diskDriveId);
	};
	
	
	//when click assign global hot spare menu or button, this method will be kicked off
	this.onClickAssignGHSMenuBtn = function()
	{
		//check out whether the selected drives contain dedicated spared disk drives
		if(hasDedictedDrivesSelected())
		{
			$("dedicated_note_td").style.display = "";
		}else{
			$("dedicated_note_td").style.display = "none";
		}
		//set the selected ids to diskdrive_ids hidden input
		$(DiskDrives.VIEW_FORM_ID+":diskdrive_ids").value=dataTableObj.getSelectedIds();
		
		launchAssignGHSDialog();
	};
	
	this.onClickUnassignGHSMenu = function()
	{
		//set the selected ids to diskdrive_ids hidden input
		$(DiskDrives.VIEW_FORM_ID+":diskdrive_ids").value=dataTableObj.getSelectedIds();
		//triger the ajax call
		$(DiskDrives.VIEW_FORM_ID+":pre_unassign_ghs_launcher").click();
	}
	//click the refresh button
	this.onClickRefreshBtn = function()
	{
		//if click the refresh button, the context will be reloaded, so the others tab pages should be reloaded as well.
		
		// Seeing which tabs are available in the framework object
		
		if(parent.parent.frameworkObj.setVolumeReload)
		{
			parent.parent.frameworkObj.setVolumeReload(true);
		}
		
		if(parent.parent.frameworkObj.setPoolReload)
		{
			parent.parent.frameworkObj.setPoolReload(true);
		}
		
		if(parent.parent.frameworkObj.setEnclosureReload)
		{
			parent.parent.frameworkObj.setEnclosureReload(true);
		}
		
		parent.$('staticLoadingFrame').contentWindow.restartFloatMessage();
		
		parent.loaded = false;
		
		parent.startShellLoading();
	}
	
	this.onClickCreatePoolMenuBtn = function()
	{
		parent.parent.parent.getElementByIdSuffix("form1:btn_diskdrive_tab_create_pool", "input").click();
	}
	
	this.onUnassignGHSAjaxComplete = function()
	{
		var ulElement = $("unprotected_pools_ul");
		var liElements = ulElement.getElementsByTagName("li");
		if(liElements != null && liElements.length > 0)
		{
			//show the confirmation dialog of the unprotected pools
			$(DiskDrives.VIEW_FORM_ID+":unassign_ghs_launcher").click();
		}else{
			//if no unprotected pools, directly unassign global spare
			$(DiskDrives.VIEW_FORM_ID+":unassign_btn_ok").click();
		}
	}
	
	this.onAjaxError = function()
	{
		parent.parent.inlineMessagesAjaxObj.displayFatalMessage();
	}
	
	//launch the locateshell jsp.
	function launchLocateDialog ()
	{
		var selectedIds = dataTableObj.getSelectedIds();
		
		// Make sure to clear out any previously selected resources
		locateObject.removeAllResourcesToLocate();
		
		// Add the currently selected object
		if(selectedIds != "")
		{
			var selectedIdArray = selectedIds.split(DataTable.ID_DELIMITER);
			for(var i=0; i<selectedIdArray.length; i++)
			{
				locateObject.addResourceToLocate(selectedIdArray[i]);
			}
		}

		locateObject.setLocateType(locateObject.DISK_CONSTANT);
		// Start the locate
		locateObject.startLocate();
	};
	
	function launchAssignGHSDialog()
	{
		$(DiskDrives.VIEW_FORM_ID+":assign_ghs_launcher").click();
	};
	
	
	
	//disable or enable locate drive button
	function changeLocateDriveBtn(flag)
	{
		var locateDriveBtn = $(DiskDrives.VIEW_FORM_ID+":locatedrive_btn");
		locateDriveBtn.disabled = flag;
	};
	
	//disable or enable assign an global hot spare button
	function changeAssignGlobalSpareBtn(flag)
	{
		var assignGlobalSpareBtn = $(DiskDrives.VIEW_FORM_ID+":assig_globalspare_btn");
		assignGlobalSpareBtn.disabled = flag;
	};
	
	
	//true if there is at least one non-internal disk drive selected
	function hasNonInternalDiskSelected()
	{
		//get selected rows
		var selectedRowElems = dataTableObj.getSelectedRowElems();
		if(selectedRowElems != null && selectedRowElems.length>0)
		{
			for(var i=0; i<selectedRowElems.length; i++)
			{
				var rowElem = selectedRowElems[i];
				var location = rowElem.cells[2].childNodes[0].childNodes[0].innerHTML;
				if(location!=internal_location)
				{
					return true;
				}
			}

		}
		return false;	
	};
	
	//if all selected drives only have unconfigured or dedicated drives, return true.
	function isAllForAssignGHSDrivesSelected()
	{
		var selectedRowElems = dataTableObj.getSelectedRowElems();
		if(selectedRowElems != null && selectedRowElems.length>0)
		{
			for(var i=0; i<selectedRowElems.length; i++)
			{
				var rowElem = selectedRowElems[i];
				var state = rowElem.cells[6].childNodes[0].childNodes[0].innerHTML;
				//if at least one non-unconfigured and non-dedicated drive has been selected, return false;
				if(state != DiskDrives.DISKDRIVE_STATE_UNCONFIGURED && state != DiskDrives.DISKDRIVE_STATE_DEDICATED)
				{
					return false;
				}
			}
		}
		return true;
	}


	//if all selected drives only have unconfigured return true.
	function isAllUnconfiguredDrivesSelected()
	{
		var selectedRowElems = dataTableObj.getSelectedRowElems();
		if(selectedRowElems != null && selectedRowElems.length>0)
		{
			for(var i=0; i<selectedRowElems.length; i++)
			{
				var rowElem = selectedRowElems[i];
				var state = rowElem.cells[6].childNodes[0].childNodes[0].innerHTML;
				//if at least one non-unconfigured and non-dedicated drive has been selected, return false;
				if(state != DiskDrives.DISKDRIVE_STATE_UNCONFIGURED)
				{
					return false;
				}
			}
		}
		return true;
	}


	
	//if all selected disk drives are global spared disk, return true;
	function isAllForUnassignGHSDrivesSelected()
	{
		var selectedRowElems = dataTableObj.getSelectedRowElems();
		if(selectedRowElems != null && selectedRowElems.length>0)
		{
			for(var i=0; i<selectedRowElems.length; i++)
			{
				var rowElem = selectedRowElems[i];
				var state = rowElem.cells[6].childNodes[0].childNodes[0].innerHTML;
				if(state != DiskDrives.DISKDRIVE_STATE_GLOBAL)
				{
					return false;
				}
			}
		}
		return true;
	}
	
	//if all selected drives only have unconfigured or dedicated drives, return true.
	function hasDedictedDrivesSelected()
	{
		var selectedRowElems = dataTableObj.getSelectedRowElems();
		if(selectedRowElems != null && selectedRowElems.length>0)
		{
			for(var i=0; i<selectedRowElems.length; i++)
			{
				var rowElem = selectedRowElems[i];
				var state = rowElem.cells[6].childNodes[0].childNodes[0].innerHTML;
				
				//if at least one dedicated drive has been selected, return true;
				if(state == DiskDrives.DISKDRIVE_STATE_DEDICATED)
				{
					return true;
				}
			}
		}
		return false;
	}
	
	//launch the properties dialog
	function launchPropertiesDialog(diskDriveId)
	{
		//set title
		setPropertiesDialogTitle();
		var action = DiskDrives.DISKDRIVE_PROPERTIES_DIALOG_PATH;
		panelDialogObj.addParameter("diskDriveId", diskDriveId); 
		panelDialogObj.launchDialogPOST(DiskDrives.VIEW_ID,action,'620');
	};

	//set the panel dialog title
	function setPropertiesDialogTitle()
	{	
		var title = $("view:dialog_title").innerHTML;
		panelDialogObj.setPanelDialogTitle(DiskDrives.VIEW_ID, title);
	};
	
	function refreshTimestamp()
	{
		$("lastrefresh_timestamp").innerHTML = getLocalizedCurrentTime();
	};
	
	//set the panel dialog title
	function setInitializeDialogTitle()
	{	
		var title = $("view:dialog_title_initialize").innerHTML;
		panelDialogObj.setPanelDialogTitle(DiskDrives.VIEW_ID, title);
	};
	
	//launch the initialize dialog
	function launchInitializeDialog(diskDriveIds)
	{
		//set title
		setInitializeDialogTitle();
		var action = DiskDrives.DISKDRIVE_INITIALIZE_DIALOG_PATH;
		panelDialogObj.addParameter("drive_ids", diskDriveIds); 
		panelDialogObj.launchDialogPOST(DiskDrives.VIEW_ID,action,'500');
	};
	
	
	//disable the "clear foreign configuration" menu
	function enableClearForeignCfItem()
	{
		var clearForeignCfItem = actionMenu.getMenuItemById(DiskDrives.VIEW_FORM_ID+":clearforeighcf_link");
		hX_5.getSubComponentById(clearForeignCfItem).setAttribute("disabled:false");
		$(DiskDrives.VIEW_FORM_ID+":clearforeighcf_link").onclick=diskDrivesObj.onClickClearForeignCfMenu;
	};
	
	//check if there is foreign drive
	function isForeignDrivesExist()
	{
		var rowElems = dataTableObj.getRowElems();
		if(rowElems != null && rowElems.length>0)
		{
			for(var i=0; i<rowElems.length; i++)
			{
				var rowElem = rowElems[i];
				var state = rowElem.cells[6].childNodes[0].childNodes[0].innerHTML;
				//if at least one is a foreign drive, return true;
				if(state == DiskDrives.DISKDRIVE_STATE_FOREIGN)
				{
					return true;
				}
			}
		}
		return false;
	};
}
